eCrash Vendor SDK Change log
---
# 2024-08-30
==**eCrash Version is now 1.13.0.1319.**==

## Partial_Source_Code Changes
**ECrashLA.Core/Models/CrashReports/Validation/Rules/TrafficwayCharacteristicsMustNotBeEmpty**
- Corrected error message to "You must select the trafficway characteristics at the location of the crash."

## Reference Data Changes
**Non Motorist Action Prior to Crash (NonMotoristActionPriorToCrash)**
- Expired "000 | None" (ID 1).

---
# 2024-07-24
==**eCrash Version is now 1.13.0.0.**==

## Data Entry Changes
- There is now no limit on the number of Drug test results that can be recorded. The limit of 4 has been removed.
- Driver Conditions prompt changed to "Check up to 2 of the factors related to the driver at the time of the crash".

## Partial_Source_Code Changes
**ECrashLA.Core/Models/CrashReports/CrashReport.cs**
- Added ReadableId property.
- Added ComputeHumanReadableId method. This method creates a human readable Id that is permanent and instantly accessible. It is computed as MMDDYY-HHmmSS-[First 4 of CrashReportId]. This should be accessible and viewable to officer at report creation.

**ECrashLA.Core/Models/CrashReports/ReferenceData/Condition.cs**
- Added IsUnderTheInfluence property.

**ECrashLA.Core/Models/CrashReports/ReferenceData/NonMotoristType.cs**
- Added DescriptionLabel property.

**ECrashLA.Core/Models/CrashReports/Validation/Rules/ConditionInfos**
- Added AlcoholKitNumberShouldHaveValueIfTestWasGiven.cs *(Warning)*
- Added AlcoholUseSuspicionOrDrugUseSuspicionShouldBeYesIfConditionInvolvesInfluenceOfAlcoholOrDrugs.cs *(Warning)*
- Added DrugKitNumberShouldHaveValueIfTestWasGiven.cs *(Warning)*

**ECrashLA.Core/Models/CrashReports/Validation/Rules/ConditionInfos/DistractionActionMustNotBeNoIfConditionIsInattentive.cs**
- Modified rule so that Distraction Action also cannot be Unknown when condition is Inattentive/distracted.

**Modified included validation rules in ECrashLA.Core/Models/CrashReports/Validation/ValidationRuleOrders.cs to include the 3 new rules.**

## Reference Data Changes
**Distraction Action (DistractionAction)**
- Expired "980 | Other distraction" (ID 4). Created new "980 | Other distraction or distraction details unknown" (ID 7).
- Expired "999 | Unknown distraction" (ID 5). Created new "999 | Unknown if distracted" (ID 8).

**Driver Action (DriverAction)**
- Expired "108 | Operated motor vehicle in inattentive, careless, negligent, or erratic manner" (ID 10). Created new "108 | Careless driving, inattentive operation, improper driving, or driving without due care" (ID 22).
- Expired "109 | Operated motor vehicle in reckless or aggressive manner" (ID 11). Created new "109 | Operating the vehicle in an erratic, reckless, or negligent manner" (ID 23).
- Added "116 | Aggressive driving" (ID 20).
- Added "117 | Road rage" (ID 21).

**Driver License Restriction (DriverLicenseRestriction)**
*Added Louisiana restriction codes and/or descriptions to applicable entries.*
- Changed "100 | Alcohol interlock device" to "100 | 51, 57 - Alcohol interlock device".
- Changed "101 | CDL intrastate only" to "101 | 52, 53, 56 - CDL intrastate only".
- Changed "102 | Corrective lenses" to "102 | 01 - Corrective lenses".
- Changed "103 | Farm waiver" to "103 | 47 - Farm waiver".
- Changed "106 | Except tractor-trailer" to "106 | 67 - Except tractor-trailer".
- Changed "107 | Intermediate license restrictions" to "107 | 61 - Intermediate license restrictions".
- Changed "108 | Learner's permit restrictions" to "108 | 02 - Learner's permit restrictions".
- Changed "109 | Limited to daylight only" to "109 | 08 - Limited to daylight only".
- Changed "110 | Limited to employment" to "110 | 50 - Hardship restricted license".
- Changed "112 | Mechanical devices (special brakes, hand controls, or other adaptive devices)" to "112 | 05, 06, 33, 34, 36, 46 - Mechanical devices (special brakes, hand controls, or other adaptive devices)"
- Changed "114 | Motor vehicles without air brakes" to "114 | 54, 68 - Motor vehicles without air brakes".
- Changed "115 | Outside mirror" to "115 | 03, 41, 42, 44, 45 - Outside mirror".
- Changed "116 | Prosthetic aid" to "116 | 40 - Wearing of artificial limb".
- Added "117 | 63 - Class B passenger endorsement" (ID 21).
- Added "118 | 64 - Class C passenger endorsement" (ID 22).

**Drug Test Result (DrugTestResult)**
- ==***All drug test results now are valid to be selected for non-fatal crashes.***==
- Expired generic "1000 | Amphetamine" (ID 5).
- Expired generic "1001 | Cocaine" (ID 6).
- Expired generic "1002 | Marijuana" (ID 7).
- Expired generic "1003 | Opiate" (ID 8).
- Expired generic "1004 | PCP" (ID 9).
- Expired generic "1090 | Other controlled substance" (ID 10).
- Expired generic "1091 | Other drug" (ID 11).

**Non-Motorist Type (NonMotoristType)**
- Changed "298 | Other pedestrian" to "298 | Other pedestrian on personal conveyance" (ID 4).
- Added "500 | Person in or on a building" (ID 7).

**Vehicle Maneuver (VehicleManeuver)**
- Expired "100 | Movements essentially straight ahead" (ID 1).
- Created new "100 - Going straight" (ID 29).
- Expired "102 | Changing lanes" (ID 3).
- Created new "102 | Merging" (ID 30).
- Expired "105 | Overtaking/passing" (ID 6).
- Expired "109 | Crossed median into opposing lane" (ID 10).
- Expired "110 | Crossed center line into opposing lane" (ID 11).
- Expired "111 | Ran off road (not while making turn at intersection)" (ID 12).
- Expired "200 | Entering traffic lane from shoulder" (ID 13).
- Created new "200 | Leaving a parking position" (ID 31).
- Expired "201 | Entering traffic lane from median" (ID 14).
- Expired "202 | Entering traffic lane from parking lane" (ID 15).
- Expired "203 | Entering traffic lane from private lane or driveway" (ID 16).
- Expired "204 | Entering freeway from on-ramp" (ID 17).
- Expired "300 | Leaving traffic lane" (ID 18).
- Created new "300 | Entering a parking position" (ID 32).
- Expired "400 | Slowing to make left turn" (ID 19).
- Created new "400 | Slowing" (ID 33).
- Expired "401 | Slowing to make right turn" (ID 20).
- Expired "402 | Slowing to stop" (ID 21).
- Expired "498 | Slowing for other reason" (ID 22).
- Expired "501 | Stopped, preparing to turn left" (ID 24).
- Created new "501 | Stopped" (ID 34).
- Expired "502 | Stopped, preparing to turn right" (ID 25).
- Expired "503 | Stopped in traffic" (ID 26).

## LUCR
- Added LUCR 2024-1 and LUCR 2024-1 data map.

## ECrashLA.Console
- Updated ECrashLA.Console application to renew the vendor token and better manage the RowVersion during batch crash report downloads.

---
# 2024-03-20
==**eCrash Version is now 1.12.0.0.**==

## Diagramming
- eCrash can now accept diagrams created in Easy Street Draw v8.1.

## Partial_Source_Code Changes
**ECrashLA.Core/Models/CrashReports/CrashFmcsaReportablity.cs**
- Added HasConditionalReportableVehicles option to enum.

**ECrashLA.Core/Models/CrashReports/VehicleFmcsaReportablity.cs**
- Added ReportableDueToVehicleConfiguration, ReportableMask, and ConditiallyReportableMask options to enum.

**ECrashLA.Core/Models/CrashReports/BusinessRules**
- Removed DetermineCrashFmcsaReportability.cs
- Added DetermineFmcsaReportability.cs

**ECrashLA.Core/Models/CrashReports/BusinessRules/VehicleRules**
- Removed DetermineVehicleFmcsaReportability.cs

**ECrashLA.Core/Models/CrashReports/ReferenceData/MotorCarrierType.cs**
- Added IsInterstate and IsIntrastate properties.

**ECrashLA.Core/Models/CrashReports/ReferenceData/VehicleColor.cs**
- Added TranciteColor property.

**ECrashLA.Core/Models/CrashReports/Validation/Rules/ConditionInfos**
- Added DrugTestResultsMustBeNotApplicableIfDrugTestStatusIsNo.cs
- Removed DrugTestResultsMustBeNotApplicableIfDrugTestStatusIsNoOrUnknown.cs
- Added DrugTestResultsMustBeUnknownIfDrugTestStatusIsUnknown.cs
- Added DrugTestTypeMustBeNotApplicableIfDrugTestStatusIsNo.cs
- Removed DrugTestTypeMustBeNotApplicableIfDrugTestStatusIsNoOrUnknown.cs
- Added DrugTestTypeMustBeUnknownIfDrugTestStatusIsUnknown.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/Trains**
- Added NumberOfCarsMustBeWithinMaximum.cs
- Added NumberOfCarsShouldBeBelowThreshold.cs

**Modified included validation rules in ECrashLA.Core/Models/CrashReports/Validation/ValidationRuleOrders.cs.**

---
# 2023-10-12
==**eCrash Version is now 1.11.0.1203.**==

## JSON_Schemas Changes
**CrashReportStatusSchema.json**
- Added ReviewPropertyNotes, ReviewPropertyNoteList, and ReviewPropertyNote objects.

## Partial_Source_Code Changes
**ECrashLA.Core/Models/CrashReports/ReferenceData/RoadwayAlignment.cs**
- Added IsNotOnTrafficway property.

**ECrashLA.Core/Models/CrashReports/ReferenceData/RoadwayGrade.cs**
- Added IsNotOnTrafficway property.

**ECrashLA.Core/Models/CrashReports/ReferenceData/TrafficwayTravelDirection.cs**
- Added IsNotOnTrafficway property.

**ECrashLA.Core/Models/CrashReports/ReferenceData/VehicleTravelDirection.cs**
- Added IsNotOnTrafficway property.

**ECrashLA.Core/Models/CrashReports/Validation/Rules/ConditionInfos**
- Added AlcoholTestResultMustBeNotApplicableIfAlcoholTestStatusIsNoOrUnknown.cs *(Bug)*
- Added AlcoholTestTypeMustBeNotApplicableIfAlcoholTestStatusIsNoOrUnknown.cs *(Bug)*
- Added DrugTestResultsMustBeNotApplicableIfDrugTestStatusIsNoOrUnknown.cs *(Bug)*
- Added DrugTestTypeMustBeNotApplicableIfDrugTestStatusIsNoOrUnknown.cs *(Bug)*

**ECrashLA.Core/Models/CrashReports/Validation/Rules/Vehicles/TravelDirectionMustBeNotOnRoadwayIfVehicleIsParked.cs**
- Modified rule to account for vehicle to not be on trafficway.

**ECrashLA.Core/Models/CrashReports/Validation/Rules/Vehicles**
- Added RoadwayAlignmentMustBeNotOnTrafficwayIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added RoadwayAlignmentMustNotBeNotOnTrafficwayIfVehicleTravelDirectionIsNotNotOnTrafficway.cs *(Bug)*
- Added RoadwayGradeMustBeNotOnTrafficwayIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added RoadwayGradeMustNotBeNotOnTrafficwayIfVehicleTravelDirectionIsNotNotOnTrafficway.cs *(Bug)*
- Added SpeedLimitMustBeNotApplicableIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TotalAuxiliaryLanesMustBeZeroIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TotalThroughLanesMustBeZeroIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TrafficControlDeviceTypesInoperativeOrMissingMustBeNoIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TrafficControlDeviceTypesPresentMustBeNoIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TrafficSignalStatusMustBeNotApplicableIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TrafficwayBarrierTypeMustBeNoneIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TrafficwayDivisionMustBeNotDividedIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TrafficwayHovLanePresenceMustBeNoIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TrafficwayHovLaneRelationMustBeNoIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TrafficwayTravelDirectionMustBeNotOnTrafficwayIfVehicleTravelDirectionIsNotOnTrafficway.cs *(Bug)*
- Added TrafficwayTravelDirectionMustNotBeNotOnTrafficwayIfVehicleTravelDirectionIsNotNotOnTrafficway.cs *(Bug)*

**ECrashLA.Core/Models/CrashReports/BusinessRules/VehicleRules/ClearWeightRatingIfVehicleConfigurationIsNotConsistent.cs**
- Modified rule to add return statement after line 22.

**ECrashLA.Core/Models/CrashReports/BusinessRules/VehicleRules**
- Removed SetAutomationSystemLevelEngagedBasedOnAutomationSystemLevelPresent.cs
- Added SetAutomationSystemLevelEngagedBasedOnVehicleTypeAndAutomationSystemLevelPresent.cs
- Added SetTrafficwayFieldsIfNotOnTrafficway.cs

**Modified included validation rules in ECrashLA.Core/Models/CrashReports/Validation/Rules/ValidationRuleOrders.cs**

## Reference Data Changes
**Direction of Travel Before Crash (VehicleTravelDirection)**
- Added 002 Not on trafficway

**Permitted Travel (TrafficwayTravelDirection)**
- Added 000 Not on trafficway

**Roadway Alignment (RoadwayAlignment)**
- Added 000 Not on trafficway

**Roadway Grade (RoadwayGrade)**
- Added 000 Not on trafficway

## LUCR
- Added LUCR 2023-2 and LUCR 2023-2 data map.

## ECrashLA.Console
- Updated ECrashLA.Console application to populate the StateCaseNumber within the CrashReport.json file.

---
# 2023-07-06
==**eCrash Version is now 1.10.0.1146.**==

## Partial_Source_Code Changes
**ECrash.Core/Models/Document**
- Added ListCannotContainNullAttribute. This allows for decorating CrashReport objects with this attribute.

**ECrash.Core/Models/Validation**
- Removed IValidationMetadataProvider.cs
- Added ListCannotContainNullValidationRuleBase.cs

**ECrash.Core/Models/Validation/ChildCompositeValidationRuleBase.cs**
- Modified RunChildRule to add exceptions as validation BUGs to crash report's validation report.

**ECrash.Core/Models/Validation/Validator.cs**
- Modified Validate to add exceptions as validation BUGs to crash report's validation report.

**ECrashLA.Core/Models/CrashReports/ConditionInfo.cs**
- Added ListCannotContainNull attribute to Conditions (ConditionList)
- Added ListCannotContainNull attribute to DrugTestResults (DrugTestResultList)

**ECrashLA.Core/Models/CrashReports/CrashReport.cs**
- Added ListCannotContainNull attribute to WeatherConditions (WeatherConditionList)
- Added ListCannotContainNull attribute to RoadwayEnvironmentalContributingCircumstances (RoadwayEnvironmentalContributingCircumstanceList)
- Added ListCannotContainNull attribute to Vehicles (VehicleList)
- Added ListCannotContainNull attribute to NonMotorists (NonMotoristList)
- Added ListCannotContainNull attribute to Trains (TrainList)
- Added ListCannotContainNull attribute to DamagedNonVehicularProperty (NonVehicularPropertyList)
- Added ListCannotContainNull attribute to Witnesses (WitnessList)
- Added ListCannotContainNull attribute to Attachments (AttachmentList)
- Added ListCannotContainNull attribute to Diagrams (DiagramList)

**ECrashLA.Core/Models/CrashReports/Driver.cs**
- Added ListCannotContainNull attribute to DriverLicenseEndorsements (DriverLicenseEndorsementList)
- Added ListCannotContainNull attribute to DriverLicenseRestrictions (DriverLicenseRestrictionList)
- Added ListCannotContainNull attribute to DriverActions (DriverActionList)
- Added ListCannotContainNull attribute to Citations (CitationList)

**ECrashLA.Core/Models/CrashReports/NonMotorist.cs**
- Added ListCannotContainNull attribute to ContributingCircumstances (NonMotoristContributingCircumstanceList)
- Added ListCannotContainNull attribute to SafetyEquipment (NonMotoristSafetyEquipmentList)

**ECrashLA.Core/Models/CrashReports/Occupant.cs**
- Added ListCannotContainNull attribute to AirBagDeployments (AirBagDeploymentList)

**ECrashLA.Core/Models/CrashReports/Train.cs**
- Added ListCannotContainNull attribute to WarningDevices (TrainWarningDeviceList)
- Added ListCannotContainNull attribute to AdvanceWarningDevices (TrainAdvanceWarningDeviceList)
- Added ListCannotContainNull attribute to ActiveWarningDeviceStatuses (TrainActiveWarningDeviceStatusList)
- Added ListCannotContainNull attribute to EquipmentStatuses (TrainEquipmentStatusList)
- Added ListCannotContainNull attribute to Passengers (TrainPassengerList)

**ECrashLA.Core/Models/CrashReports/Vehicle.cs**
- Added ListCannotContainNull attribute to TrafficControlDevicesPresent (TrafficControlDeviceTypeList)
- Added ListCannotContainNull attribute to TrafficControlDevicesInoperativeOrMissing (TrafficControlDeviceTypeList)
- Added ListCannotContainNull attribute to DamagedAreas (VehicleAreaList)
- Added ListCannotContainNull attribute to SequenceOfEvents (SequenceOfEvents)
- Added ListCannotContainNull attribute to Passengers (PassengerList)
- Added ListCannotContainNull attribute to Trailers (VehicleTrailerList)
- Added ListCannotContainNull attribute to VehicleSpecialSizings (VehicleSpecialSizingList)

**ECrashLA.Core/Models/CrashReports/Validation**
- Removed MetadataProviders directory

**ECrashLA.Core/Models/CrashReports/Validation/Rules**
- Added FirstHarmfulEventMustBeAHarmfulEvent *(Bug)*
- Modified included validation rules in ECrashLA.Core/Models/CrashReports/Validation/Rules/ValidationRuleOrders.cs

**Added BUG validation rule to ensure submitted crash reports have ModifierSignature populated.**

---
# 2023-06-06
==**eCrash Version is now 1.10.0.1146.**==

## JSON_Schemas Changes

**CrashReportSchema.json**
- Added EffectiveVersion and ExpirationVersion properties to ReferenceDataBase.

## Partial_Source_Code Changes
- Changes references of IValidationMetadataProvider to IMetadataProvider

**ECrashLA.Core/Models/CrashReports/Validation/Rules**
- Removed Vehicles/VehicleUsageMustNotBeEmergencyIfEmergencyVehicleUsageIsNotApplicableOrUnknown *(Error)*
- Removed validation rule in ECrashLA.Core/Models/CrashReports/Validation/Rules/ValidationRuleOrders.cs

## Reference Data Changes
- Vehicle Automation System Level - Added "(SAE Level #)" to each automation option.
	
## ECrashLA.Console
- Updated application to allow for freshening of crash report's reference data and business rules.

## Documentation
**Louisiana eCrash API Information**
- Added population instructions for Vehicle.Driver object when a vehicle has no driver at the time of the crash or the driver is unable to be determined in Upload Crash Report Data section.
- Added population instructions for Train.Engineer and Train.Conductor objects when a train has no engineer or conductor present at the time of the crash in Upload Crash Report Data section.

---
# 2023-02-23
==**eCrash Version is now 1.9.0.1089.**==

## Partial_Source_Code Changes
**ECrashLA.Core/Models/CrashReports/Validation/Rules**
- Removed CrashMannerShouldBeCollisionBetweenTwoMotorVehiclesWhenAllVehiclesAreInTransport.cs *(Warning)*
- Modified included validation rules in ECrashLA.Core/Models/CrashReports/Validation/Rules/ValidationRuleOrders.cs

---
# 2023-02-01
==**eCrash Version is now 1.8.0.1070.**==

## Partial_Source_Code Changes
**ECrash.Core/Models/ReferenceData/ReferenceDataAddition.cs**
- Added EffectiveVersion and ExpirationVersion assignments to Apply method.

**ECrash.Core/Models/ReferenceData/ReferenceDataBase.cs**
- Added EffectiveVersion and ExpirationVersion assignments to Clone method.
- Added EffectiveVersion and ExpirationVersion checks to IsEquivalentTo method.

**ECrash.Core/Models/ReferenceData/ReferenceDataModificationBase.cs**
- Added EffectiveVersion and ExpirationVersion properties.

**ECrash.Core/Models/ReferenceData/ReferenceDataModification.cs**
- Added EffectiveVersion and ExpirationVersion assignments to Apply method.

**ECrashLA.Core/Models/CrashReports/ReferenceData/CrashManner.cs**
- Added HelpTextField and HelpTopicField.

**ECrashLA.Core/Models/CrashReports/ReferenceData**
- Added CrashMannerDrawing.cs

**ECrashLA.Core/Models/CrashReports/AgencySettings.cs**
- Added LocalCaseNumberFormats property and MergeActiproRegexes method.

**ECrashLA.Core/Models/CrashReports**
- Added LocalCaseNumberFormat.cs

**ECrashLA.Core/Models/CrashReports/BusinessRules/VehicleRules/SetVehicleAndDriverFieldsBasedOnHitAndRun.cs**
- No longer setting the Vehicle Type field.

**ECrashLA.Core/Models/CrashReports/Validation/Rules**
- Added CrashMannerShouldNotBeOther.cs (Severe Warning)
- Added LocalCaseNumberMustMatchAConfiguredFormatIfApplicable.cs *(Error)*
- Added CrashMannerShouldBeCollisionBetweenTwoMotorVehiclesWhenAllVehiclesAreInTransport.cs *(Warning)*

**ECrashLA.Core/Models/CrashReports/Validation/Rules/ValidationRuleOrders.cs**
- Modified included validation rules.	

## Reference Data Changes
**Crash Manner**
- Added help text to "000 - Not a collision between two motor vehicles in transport", "400 - Backing - rear to front", and "401 - Backing - rear to rear".
- Expired values "201, 202, 503, and 504".
- Updated "101" name to "Angle - left opposite direction".
- Updated "104" order to 100.104
- Updated "500" name to "Angle - left across flow". Category to "Angle". Order to 105.1.
- Updated "501" name to "Angle - right across flow". Category to "Angle". Order to 105.2.
- Updated "502" name to "Sideswipe - opposite direction". Order to 200.502.
- Updated "505" name to "Sideswipe - same direction". Order to 200.505.

**Vehicle Body Type**
- Updated category "Cycle / Low Speed" to "Cycle / Off Road / Recreation".
- Added Crash Manner Drawing

## LUCR
- Added LUCR 2023-1 and LUCR 2023-1 data map.
- Updated all previous LUCR revisions with change to Vehicle Body Type "Cycle / Off Road / Recreation" category.

## Documentation
**Louisiana eCrash API Information**
- Revision notes included in document's change history.

---
# 2022-11-21
==**eCrash Version is now 1.7.0.999.**==

## Partial_Source_Code Changes
**ECrash.Core/Models/Document/DocumentRoot.cs**
- Added support to report unrecognized reference data values.

**ECrash.Core/Models/ReferenceData**
- Added ReferenceDataMissingException.cs

**ECrashLA.Core/Models/CrashReports/BusinessRules/VehicleRules**
- Added ClearMotorCarrierAddressIfUnknown.cs
- Added ClearMotorCarrierNameIfUnknown.cs

**ECrashLA.Core/Models/CrashReports/ReferenceData**
- VehicleBodyType.cs - Modified NhtsaValueIds setter property array initialization.
- VehicleMake.cs - Modified Abbreviation and NhtsaValueIds setter property array initialization.
- VehicleModel.cs - Modified Abbreviation, FarsCodes, and NhtsaValueIds setter property array initialization.
- WeightRating.cs - Added support for NhtsaValueIds.

**ECrashLA.Core/Models/CrashReports/Validation/Rules/ConditionInfos**
- Removed AlcoholUseSuspicionMustNotBeUnknownIfDriverDidNotLeaveScene.cs
- Removed DrugUseSuspicionMustNotBeUnknownIfDriverDidNotLeaveScene.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/Vehicles**
- Added MotorCarrierAddressMustBeNullIfUnknown.cs
- Added MotorCarrierInformationShouldBeConsistentWithVehicleConfigurationAndWeightRating.cs
- Added MotorCarrierNameMustBeNullIfUnknown.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/WorkZoneRelationMustBeYesIfRoadwayEnvironmentalContributingCircumstancesIncludesWorkZone.cs**
- Modified rule from bug to error.

**ECrashLA.Core/Models/CrashReports/Validation/Rules/ValidationRuleOrders.cs**
- Modified included validation rules.

## Reference Data Changes
**Motor Carrier Type**
- Removed "No" tag for 001 - Not in commerce:government
- Removed "No" tag for 002 - Not in commerce:personal rental truck or bus

---
# 2022-10-13
==**eCrash Version is now 1.6.0.955.**==

## Partial_Source_Code Changes
**ECrashLA.Core/Models/CrashReports/CrashReport.cs**
- Added JsonSchemaNotNullable attributes to ModifierSignature and ModifierSignatureTimestamp fields.

**ECrashLA.Core/Models/CrashReports/Train.cs**
- Added JsonSchemaComment attributes to Engineer and Conductor fields.

**ECrashLA.Core/Models/CrashReports/Vehicle.cs**
- Added JsonSchemaComment attribute to Driver field.

**ECrashLA.Core/Models/CrashReports/BusinessRules/VehicleRules**
- Added ClearMotorCarrierPhoneNumberIfUnknown.cs

**ECrashLA.Core/Models/CrashReports/BusinessRules/DriverRules/ClearDriverLicenseFieldsIfDriverLicenseStatusDoesNotRequireInformation.cs**
- Modified business rule for NotLicensed and Unknown driver license statuses.

**ECrashLA.Core/Models/CrashReports/ReferenceData/DriverLicenseStatus.cs**
- Added support for NotLicensed tag.

**ECrashLA.Core/Models/CrashReports/Validation/Rules/Conductors**
- Added MedicalUniqueIdentifierMustNotBeNotApplicableAndUnknown.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/Drivers**
- Modified AlcoholInterlockPresenceMustNotBeEmpty.cs to always require AlcoholInterlockPresence.
- Modified EndorsementComplianceMustBeEndorsementsRequiredIfVehicleIsSchoolBus.cs to ignore driver license status.
- Modified EndorsementComplianceMustNotBeEmpty.cs to ignore driver license status.
- Added MedicalUniqueIdentifierMustNotBeNotApplicableAndUnknown.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/Engineers**
- Added MedicalUniqueIdentifierMustNotBeNotApplicableAndUnknown.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/NonMotorists**
- Added MedicalUniqueIdentifierMustNotBeNotApplicableAndUnknown.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/Passengers**
- Added MedicalUniqueIdentifierMustNotBeNotApplicableAndUnknown.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/People**
- Added MedicalUniqueIdentifierMustNotBeNotApplicableAndUnknownBase.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/TrainPassengers**
- Added MedicalUniqueIdentifierMustNotBeNotApplicableAndUnknown.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/Trains**
- Added StruckCarNumberMustNotBeNotApplicableAndUnknown.cs
- Added StruckCarPositionMustNotBeNotApplicableAndUnknown.cs
- Added StruckCarTypeMustNotBeNotApplicableAndUnknown.cs
- Added TrainIdNumberMustNotBeNotApplicableAndUnknown.cs

**ECrashLA.Core/Models/CrashReports/Validation/Rules/Vehicles**
- Added SkidmarkLengthMustNotBeNotApplicableAndUnknown.cs
- Added SpeedLimitMustNotBeNotApplicableAndUnknown.cs

**ECrashLA.Core/Models/CrashReports/Validation/ValidationRuleOrders.cs**
- Included added validation rules.

## Reference Data changes
**Vehicle Model**
- Added "1477 - Express Van"

**Violation Category**
- Added 450 - Drug Law
- Added 550 - Miscellaneous Reporting Provisions

**Violation Code**
- Added 32:383 Loads on vehicles; care required thereto; penalties; definition
- Added 47:508 Registration; commercial vehicles; exemption
- Added 32:361.1 View outward or inward through windshield or windows; obscuring prohibited
- Added 32:1301 Vehicles without required equipment or in unsafe condition
- Added 32:408c No Motorcycle Endorsement
- Added 47:506 Expired Registration
- Added 32:300.5 Texting While Driving
- Added 32:300.6 Under age use of wireless telecommunications
- Added 32:300.7 Use of Certain Wireless Telecommunications Devices by Minors While Driving Prohibited
- Added 32:300.8 Use of Wireless Telecommunications Devices in School Zones Prohibited
- Added 47:513.2 Failure to transfer title
- Added 32:398 Failure to Report Crash
- Added 32:412 Expired DL
- Added 47:536 Violations of Registration (fake temp tag)
- Added 40:966 Possession, and/or Possession with intent to distribute, Schedule 1 narcotics (Marijuana, Synthetic Marijuana, and Heroin).
- Added 14:98.8 Suspended DL from previous DWI
- Added 40:1023 Illegal Possession of Drug Paraphernalia

## Documentation
- Replaced LA eCrash Data Element Manual with LA Uniform Crash Report Manual
- Updated Louisiana eCrash API Information.pdf. Revision notes included in document's change history.
- Updated LUCRs with changes to indicate no train engineer or no train conductor.

---
# 2022-10-03
## LUCR
- Updated LUCR to correct typo in Vehicle Traffic Control Device Type "204 - Railroad crossing sign"

---
# 2022-09-30
## Partial_Source_Code Changes
- Added eCrash.Core/Models/GeographicPoint.cs
- Added eCrash.Core/Models/UtmGeographicBorder.cs
- Added eCrash.Core/Models/UtmGeographicPolygon.cs

---
# 2022-09-28
## Partial_Source_Code Changes
**ECrashLA.Core/Models/CrashReports/ReferenceData/LicensePlateType.cs**
- Added support for Personalized tag.

**ECrashLA.Core/Models/CrashReports/ReferenceData/VehicleColor.cs**
- Replaced ArgumentNullException with "false" in respective IsMatch* method.

**ECrashLA.Core/Models/CrashReports/ReferenceData/VehicleModel.cs**
- Replaced ArgumentNullException with "false" in respective IsMatch* method.

**ECrashLA.Core/Models/CrashReports/BusinessRules/VehicleRules**
- Added SetEmergencyVehicleUsageBasedOnVehicleUsage.cs
	
## Reference Data Changes
- Added "104 - Personalized" to LicensePlateType.
- Updated "101 - Towed due to disabling damage" to "101 - Towed (or will be towed) due to disabling damage".

## LUCR
Updated LUCR 2022-2 PDF and LUCR 2022-2 Data Map PDF with changes to Tow Status.

---
# 2022-09-20
## Partial_Source_Code Changes
**ECrash.Core/Models/Document/DocumentValueCollectionWithoutDuplicates.cs**
- Added ReferenceDataBase check in InsertItemBase and SetItemBase.

**Crash.Core/Models/ReferenceData/CommonTags.cs**
- Added method to retrieve "Default" tag.

**Crash.Core/Models/ReferenceData/ReferenceDataFilter.cs**
- Added GetFirstWithTag and GetFirstOrDefaultWithTag methods.

**CrashLA.Core/Models/CrashReports/BusinessRules/ConditionalInfoRules/SetDistractionSourceBasedOnDistractionAction.cs**
- Added check for an Inattentive Distraction Action to set Distraction Source to Not Applicable.

**CrashLA.Core/Models/CrashReports/ReferenceData/Condition.cs**
- Added support for Inattentive tag.

**CrashLA.Core/Models/CrashReports/ReferenceData/DistractionAction.cs**
- Added support for Inattentive tag.

**CrashLA.Core/Models/CrashReports/ReferenceData/HazardousMaterialClass.cs**
- Added support for DescribeInNarrative tag.

**CrashLA.Core/Models/CrashReports/Validation/Rules/ConditionInfos**
- Added DistractionActionMustNotBeNoIfConditionIsInattentive.cs
- Added DistractionSourceMustBeNotApplicableIfDistractionActionIsInattentive.cs

**CrashLA.Core/Models/CrashReports/Validation/Rules/Engineers**
- Added CertificationNumberMustBeNullIfUnknown.cs
- Added CertificationNumberMustNotBeEmptyIfApplicable.cs

**CrashLA.Core/Models/CrashReports/Validation/Rules/Trains**
- Added ActiveWarningDeviceStatusesMustNotViolateMutualExclusion.cs
- Added AdvanceWarningDevicesMustNotViolateMutualExclusion.cs
- Added DataRecorderSpeedMustBeNullIfPending.cs
- Added DataRecorderSpeedMustNotBeEmptyIfApplicable.cs
- Added DataRecorderSpeedMustNotBeLessThanZero.cs
- Added DataRecorderSpeedMustNotBePendingIfNoDataRecorderWasEquipped.cs
- Added EquipmentStatusesMustNotBeEmpty.cs
- Added EquipmentStatusesMustNotViolateMutualExclusion.cs
- Added EstimatedSpeedBeforeBrakingMustNotBeEmpty.cs
- Added EstimatedSpeedBeforeBrakingMustNotBeLessThanZero.cs
- Added NumberOfEnginesMustBeGreaterThanZero.cs
- Added NumberOfEnginesMustBeNullIfUnknown.cs
- Added NumberOfEnginesMustNotBeEmptyIfApplicable.cs
- Added SerialNumberMustBeNullIfUnknown.cs
- Added SerialNumberMustBeWithinMaximumLength.cs
- Added SerialNumberMustNotBeEmptyIfApplicable.cs
- Added SetsOfTracksMustBeGreaterThanZero.cs
- Added SetsOfTracksMustNotBeEmpty.cs
- Added StruckCarPositionMustBeNullIfNotApplicable.cs
- Added StruckCarPositionMustBeNullIfUnknown.cs
- Added StruckCarPositionMustNotBeEmptyIfApplicable.cs
- Added TrackSpeedLimitMustBeGreaterThanZero.cs
- Added TrackSpeedLimitMustNotBeEmpty.cs
- Added TypeMustBeNullIfUnknown.cs
- Added TypeMustBeWithinMaximumLength.cs
- Added TypeMustNotBeEmptyIfApplicable.cs
- Added WarningDevicesMustNotViolateMutualExclusion.cs

**CrashLA.Core/Models/CrashReports/Validation/ValidationRuleOrders.cs**
- Added newly created validation rules to the order.

## JSON_Schemas Changes
**CrashReportSchema**
- Altered CrashReport.LastUpdatedWithVersion to be required.
- Altered CrashReport.ModifierSignature to be required.
- Altered CrashReport.ModifierSignatureTimestamp to be required.

## Reference Data Changes
- Added "EventDataRecorderEquipped" tag to Train Equipment Status "104 - Event data recorder equipped".
- Removed "098 - Not in commerce:other" from Motor Carrier Type.
- Added "default*" tags to all applicable reference data options.
- Updated CodeNumbers for "801 - Seat belt law" and "802 - Child restraint law".
- Added subclass entries to Hazardous Material Class.
- Added "200 - Inattentive" to Distraction Action.
- Added "106 - Inattentive/distracted" to Condition.
- Updated Distraction Action "980 - Other" to "980 - Other Distraction"
- Updated Distraction Action "999 - Unknown" to "999 - Unknown Distraction"
- Updated Vehicle Event "203 - Collision with pedalcycle" to "203 - Collision with pedalcycle (including bicycles)"

## Documentation
- Added URLs to TEST environment for Reference Data JSON, Reference Data Web, and Validation Rules Web.

## LUCR
- Added LUCR 2022-2 PDF and LUCR 2022-2 Data Map PDF.