﻿using System;

namespace ECrash.Core.Models.Document;

public class AttachmentCorruptedException : Exception
{
	public AttachmentCorruptedException(string id, Filename filename, int expectedLength, Hash expectedHash, int actualLength, Hash actualHash)
		: base($"Attachment \"{filename}\" had length {actualLength} and hash {actualHash} instead of expected length {expectedLength} and expected hash {expectedHash}.")
	{
		Id = id;
		Filename = filename;
		ExpectedLength = expectedLength;
		ExpectedHash = expectedHash;
		ActualLength = actualLength;
		ActualHash = actualHash;
	}

	public string Id { get; }
	public Filename Filename { get; }
	public int ExpectedLength { get; }
	public Hash ExpectedHash { get; }
	public int ActualLength { get; }
	public Hash ActualHash { get; }
}