﻿using System;

namespace ECrash.Core.Models.Document;

public class AttachmentDuplicateException : Exception
{

	public string Id { get; }
	public Filename Filename { get; }
	public int Length { get; }
	public Hash Hash { get; }

	public AttachmentDuplicateException(string id, Filename filename, int length, Hash hash)
		: base($"Attachment \"{id}\" already exists in the database.")
	{
		Id = id;
		Filename = filename;
		Length = length;
		Hash = hash;
	}
}