﻿using System;

namespace ECrash.Core.Models.Document;

public class AttachmentMissingException : Exception
{
	public string Id { get; }
	public Filename Filename { get; }
	public int Length { get; }
	public Hash Hash { get; }

	public AttachmentMissingException(string id, Filename filename, int length, Hash hash)
		: base($"Attachment \"{id}\" was not found in the database.")
	{
		Id = id;
		Filename = filename;
		Length = length;
		Hash = hash;
	}
}