﻿using System;

namespace ECrash.Core.Models.Document;

public abstract class DocumentChild<TRoot> : DocumentNode<TRoot>
	where TRoot : DocumentRoot<TRoot>
{
	public Guid NodeId { get; protected set; } = Guid.NewGuid();
	public override TRoot Root { get; protected set; }
	public override IDocumentNode<TRoot> Parent { get; protected set; }

	public override void NotifyOfDocumentPropertyChange(DocumentPropertyChangedEventArgs args)
	{
		Root?.NotifyOfDocumentPropertyChange(args);
	}
}