﻿using System;
using System.Collections;
using System.Collections.Specialized;
using JetBrains.Annotations;

namespace ECrash.Core.Models.Document;

public class DocumentCollectionChangedEventArgs : EventArgs
{
	private readonly NotifyCollectionChangedEventArgs _changes;

	public DocumentCollectionChangedEventArgs([NotNull] object source, [NotNull] NotifyCollectionChangedEventArgs changes)
	{
		Source = source;
		_changes = changes;
	}

	public object Source { get; }

	public NotifyCollectionChangedAction Action => _changes.Action;

	public IList NewItems => _changes.NewItems;

	public int NewStartingIndex => _changes.NewStartingIndex;

	public IList OldItems => _changes.OldItems;

	public int OldStartingIndex => _changes.OldStartingIndex;
}