﻿using System.Collections;
using Newtonsoft.Json;

namespace ECrash.Core.Models.Document;

public abstract class DocumentCollectionChild<TRoot> : DocumentChild<TRoot>, INeedsCollectionIndex
	where TRoot : DocumentRoot<TRoot>
{
	[JsonIgnore]
	public int Index
	{
		get
		{
			var collection = Parent as IList;
			return collection?.IndexOf(this) ?? -1;
		}
	}

	[JsonIgnore]
	public int Number => Index + 1;

	public virtual void OnCollectionIndexChanged()
	{
		NotifyOfPropertyChange(nameof(Index));
		NotifyOfPropertyChange(nameof(Number));
	}
}