﻿using ECrash.Core.Database;

namespace ECrash.Core.Models.Document;

public abstract class DocumentLoadStrategyBase<TDocument> : IDocumentLoadStrategy<TDocument> where TDocument : DocumentRoot<TDocument>
{
	public bool ModifiedDuringLoad { get; set; }

	public virtual bool OnCorruptAttachment(IAsyncDatabaseSession session, TDocument document, AttachmentBase<TDocument> attachment)
	{
		return false;
	}

	public virtual bool OnMissingAttachment(IAsyncDatabaseSession session, TDocument document, AttachmentBase<TDocument> attachment)
	{
		return false;
	}
}