﻿namespace ECrash.Core.Models.Document;

public static class DocumentNodeExtensions
{
	public static TTarget InitParent<TTarget, TRoot>(this TTarget target, IDocumentNode<TRoot> parent)
		where TTarget : IDocumentNode<TRoot>
		where TRoot : IDocumentNode<TRoot>
	{
		target.UpdateLinks(parent);
		return target;
	}

	public static bool TryGetParent<TRoot, TParent>(this IDocumentNode<TRoot> child, out TParent parent)
		where TRoot : class, IDocumentNode<TRoot>
		where TParent : class, IDocumentNode<TRoot>
	{
		if (child == null)
		{
			parent = null;
			return false;
		}
		if (child is TParent p)
		{
			parent = p;
			return true;
		}
		return TryGetParent(child.Parent, out parent);
	}
}