﻿using System;
using Newtonsoft.Json;

namespace ECrash.Core.Models.Document;

public class FilenameJsonConverter : JsonConverter<Filename>
{
	public override void WriteJson(JsonWriter writer, Filename value, JsonSerializer serializer)
	{
		writer.WriteValue(value.ToString());
	}

	public override Filename ReadJson(JsonReader reader, Type objectType, Filename existingValue, bool hasExistingValue, JsonSerializer serializer)
	{
		if (reader.Value is string value)
		{
			return new Filename(value);
		}
		throw new InvalidOperationException("Unable to read Filename from JSON");
	}
}