﻿using System;
using Newtonsoft.Json;

namespace ECrash.Core.Models.Document;

public class HashJsonConverter : JsonConverter<Hash>
{
	public override void WriteJson(JsonWriter writer, Hash value, JsonSerializer serializer)
	{
		writer.WriteValue(value.ToString());
	}

	public override Hash ReadJson(JsonReader reader, Type objectType, Hash existingValue, bool hasExistingValue, JsonSerializer serializer)
	{
		if (reader.Value is string value)
		{
			return new Hash(value);
		}
		throw new InvalidOperationException("Unable to read Hash from JSON");
	}
}