﻿namespace ECrash.Core.Models.Document;

// ReSharper disable once TypeParameterCanBeVariant
public interface IBusinessRule<TDocument> where TDocument : DocumentRoot<TDocument>
{
	void OnInitialize(TDocument document);
	void OnPropertyChange(TDocument document, DocumentPropertyChangedEventArgs change);
	void OnCollectionChange(TDocument document, DocumentCollectionChangedEventArgs change);
	void OnNodeAttached(TDocument document, IDocumentNode<TDocument> node);
	void OnNodeDetached(TDocument document, IDocumentNode<TDocument> node);
}