﻿using ECrash.Core.Database;

namespace ECrash.Core.Models.Document;

public interface IDocumentLoadStrategy<TDocument> where TDocument : DocumentRoot<TDocument>
{
	bool ModifiedDuringLoad { get; set; }

	bool OnCorruptAttachment(IAsyncDatabaseSession session, TDocument document, AttachmentBase<TDocument> attachment);
	bool OnMissingAttachment(IAsyncDatabaseSession session, TDocument document, AttachmentBase<TDocument> attachment);
}