﻿using System.Collections.Generic;

namespace ECrash.Core.Models.Document;

// ReSharper disable once TypeParameterCanBeVariant
public interface IDocumentNode<TRoot>
{
	TRoot Root { get; }
	IDocumentNode<TRoot> Parent { get; }
	void UpdateLinks(IDocumentNode<TRoot> parent);
	void BeginUpdateLinks(IDocumentNode<TRoot> parent);
	void EndUpdateLinks(IDocumentNode<TRoot> parent);
	IEnumerable<IDocumentNode<TRoot>> EnumerateChildNodes();
}