﻿using System;
using Newtonsoft.Json;

namespace ECrash.Core.Models.Document;

/// <summary>
/// Represents a recently opened document that's been logged for convenience.
/// </summary>
public abstract class RecentDocument
{
	public Guid Id { get; set; }
		
	public DateTime? LastAccessedTimestamp { get; set; }

	protected bool Equals(RecentDocument other)
	{
		return Id.Equals(other.Id);
	}

	public override bool Equals(object obj)
	{
		if (ReferenceEquals(null, obj)) return false;
		if (ReferenceEquals(this, obj)) return true;
		if (obj.GetType() != this.GetType()) return false;
		return Equals((RecentDocument) obj);
	}

	// ReSharper disable NonReadonlyFieldInGetHashCode
	public override int GetHashCode()
	{
		return Id.GetHashCode();
	}
}