﻿using System;
using System.Linq;

namespace ECrash.Core.Models.ReferenceData;

public class ReferenceDataAddition : ReferenceDataModificationBase
{
	public override void Apply(ReferenceDataList referenceData)
	{
		var type = ReferenceDataMetadata.Types.First(x => x.Name == Type);
		int maxId = referenceData.GetAllDataOfType(type).MaxOrDefault(x => x.Id);
		var value = (ReferenceDataBase)Activator.CreateInstance(type, maxId + 1, RowVersion.Empty);
		value.Code = Code;
		value.Name = Name;
		value.Category = Category;
		value.Order = Order;
		value.EffectiveDate = EffectiveDate;
		value.ExpirationDate = ExpirationDate;
		value.EffectiveVersion = EffectiveVersion;
		value.ExpirationVersion = ExpirationVersion;
		value.Tags.UnionWith(Tags);
		foreach (var pair in Fields)
		{
			value.Fields[pair.Key] = pair.Value;
		}

		referenceData.Add(Type, value);
	}
}