﻿using System.Collections.Generic;

namespace ECrash.Core.Models.ReferenceData;

public class ReferenceDataChangeset
{
	public List<ReferenceDataAddition> Additions { get; } = new List<ReferenceDataAddition>();
	public List<ReferenceDataModification> Modifications { get; } = new List<ReferenceDataModification>();

	public void Apply(ReferenceDataList referenceData)
	{
		foreach (var addition in Additions)
		{
			addition.Apply(referenceData);
		}
		foreach (var modification in Modifications)
		{
			modification.Apply(referenceData);
		}
	}

	public ReferenceDataList ApplyToCopy(ReferenceDataList referenceData)
	{
		var clone = referenceData.VersionedClone();
		Apply(clone);
		return clone;
	}
}