﻿using System.Collections.Generic;

namespace ECrash.Core.Models.ReferenceData;

public class ReferenceDataIdEqualityComparer : IEqualityComparer<ReferenceDataBase>
{
	public static readonly ReferenceDataIdEqualityComparer Instance = new ReferenceDataIdEqualityComparer();

	public bool Equals(ReferenceDataBase x, ReferenceDataBase y)
	{
		if (ReferenceEquals(x, y)) return true;
		if (x == null || y == null) return false;
		return x.Id == y.Id;
	}

	public int GetHashCode(ReferenceDataBase obj)
	{
		return obj.Id.GetHashCode();
	}
}