using System;
using System.Collections.Generic;
using System.Linq;
using ECrash.Core.Ioc;

namespace ECrash.Core.Models.ReferenceData;

public static class ReferenceDataMetadata
{
	public static List<Type> Types { get; }

	static ReferenceDataMetadata()
	{
		Types = ECrashTypeLists.Assemblies
		                       .SelectMany(x => x.GetTypes().Where(t => typeof(ReferenceDataBase).IsAssignableFrom(t) 
		                                                                && !t.IsAbstract
		                                                                && t != typeof(UnknownReferenceDataType)))
		                       .ToList();
	} 
}