﻿using System;

namespace ECrash.Core.Models.ReferenceData;

public class ReferenceDataModification : ReferenceDataModificationBase
{
	public int Id { get; set; }

	public override void Apply(ReferenceDataList referenceData)
	{
		var value = referenceData.GetById(Type, Id);
		if (value == null) throw new InvalidOperationException($"No reference data of type {Type} with ID {Id} exists.");
		referenceData.Update(value,
		                     x =>
		                     {
			                     x.Code = Code;
			                     x.Name = Name;
			                     x.Category = Category;
			                     x.Order = Order;
			                     x.EffectiveDate = EffectiveDate;
			                     x.ExpirationDate = ExpirationDate;
			                     x.EffectiveVersion = EffectiveVersion;
			                     x.ExpirationVersion = ExpirationVersion;
			                     x.Tags.Clear();
			                     x.Tags.UnionWith(Tags);
			                     x.Fields.Clear();
			                     foreach (var pair in Fields)
			                     {
				                     x.Fields[pair.Key] = pair.Value;
			                     }
		                     });
	}
}