﻿using System;
using System.Collections.Generic;
using System.Text;
using ECrash.Core.Models;

namespace ECrashLA.Core.Models.CrashReports;

public class AgencySettings : AgencySettingsBase<Guid>
{
	public string AddressStreet { get; set; }
	public string AddressCity { get; set; }
	public string AddressState { get; set; }
	public string AddressPostalCode { get; set; }
	public string PhoneNumber { get; set; }
	public string ReportRetrievalInstructions { get; set; }
	public string DivisionLabel { get; set; }
	public List<string> DivisionValues { get; } = new();
	public List<LocalCaseNumberFormat> LocalCaseNumberFormats { get; } = new();

	public string MergeActiproRegexes()
	{
		if (LocalCaseNumberFormats.Count == 0) return null;
		if (LocalCaseNumberFormats.Count == 1) return LocalCaseNumberFormats[0].ActiproRegex;
		var sb = new StringBuilder();
		string separator = string.Empty;
		foreach (var format in LocalCaseNumberFormats)
		{
			sb.Append(separator).Append('(').Append(format.ActiproRegex).Append(')');
			separator = "|";
		}
		return sb.ToString();
	}
}