using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.CitationRules
{
	public class ClearViolationCodeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Citation>
	{
		public ClearViolationCodeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Citation.ViolationCode))
		{
		}

		protected override void ApplyRule(Citation model, ReferenceDataFilter referenceData)
		{
			if (model.ViolationCode == null || !model.ViolationCode.RequiresDescription)
			{
				model.ViolationCodeDescription = null;
			}
		}
	}
}