using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.CitationRules
{
	public class SetViolationCategoryFromViolationCode : CrashReportChildBusinessRuleBase<Citation>
	{
		public SetViolationCategoryFromViolationCode(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Citation.ViolationCode))
		{
		}

		protected override void ApplyRule(Citation model, ReferenceDataFilter referenceData)
		{
			string violationCategoryCode = model.ViolationCode?.ViolationCategory;
			model.ViolationCategory = referenceData.GetFirstOrDefault<ViolationCategory>(x => x.Code == violationCategoryCode);
		}
	}
}