using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class ClearCrashMannerDescriptionIfNotRequired : CrashReportBusinessRuleBase
	{
		public ClearCrashMannerDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.CrashManner))
		{
		}

		protected override void ApplyRule(CrashReport model, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (model.CrashManner == null || !model.CrashManner.RequiresDescription)
			{
				model.CrashMannerDescription = null;
			}
		}
	}
}