﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class ClearDistanceFromIntersectionIfNotApplicable : CrashReportBusinessRuleBase
	{
		public ClearDistanceFromIntersectionIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.IsDistanceFromIntersectionNotApplicable))
		{
		}

		protected override void ApplyRule(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (document.IsDistanceFromIntersectionNotApplicable)
			{
				document.DistanceFromIntersection = null;
				document.DistanceFromIntersectionUnit = null;
			}
		}
	}
}