using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class ClearFirstHarmfulEventDescriptionIfNotRequired : CrashReportBusinessRuleBase
	{
		public ClearFirstHarmfulEventDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.FirstHarmfulEvent))
		{
		}

		protected override void ApplyRule(CrashReport model, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (model.FirstHarmfulEvent == null || !model.FirstHarmfulEvent.RequiresDescription)
			{
				model.FirstHarmfulEventDescription = null;
			}
		}
	}
}