using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class ClearJunctionLocationDescriptionIfNotRequired : CrashReportBusinessRuleBase
	{
		public ClearJunctionLocationDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.JunctionLocation))
		{
		}

		protected override void ApplyRule(CrashReport model, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (model.JunctionLocation == null || !model.JunctionLocation.RequiresDescription)
			{
				model.JunctionLocationDescription = null;
			}
		}
	}
}