using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class ClearLightConditionDescriptionIfNotRequired : CrashReportBusinessRuleBase
	{
		public ClearLightConditionDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.LightCondition))
		{
		}

		protected override void ApplyRule(CrashReport model, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (model.LightCondition == null || !model.LightCondition.RequiresDescription)
			{
				model.LightConditionDescription = null;
			}
		}
	}
}