using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class ClearRoadwayEnvironmentalContributingCircumstancesDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<CrashReport, RoadwayEnvironmentalContributingCircumstanceList, RoadwayEnvironmentalContributingCircumstance>
	{
		public ClearRoadwayEnvironmentalContributingCircumstancesDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(CrashReport model, RoadwayEnvironmentalContributingCircumstanceList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.RoadwayEnvironmentalContributingCircumstancesDescription = null;
			}
		}
	}
}