using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class ClearRoadwaySurfaceConditionDescriptionIfNotRequired : CrashReportBusinessRuleBase
	{
		public ClearRoadwaySurfaceConditionDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.RoadwaySurfaceCondition))
		{
		}

		protected override void ApplyRule(CrashReport model, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (model.RoadwaySurfaceCondition == null || !model.RoadwaySurfaceCondition.RequiresDescription)
			{
				model.RoadwaySurfaceConditionDescription = null;
			}
		}
	}
}