using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class ClearWeatherConditionsDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<CrashReport, WeatherConditionList, WeatherCondition>
	{
		public ClearWeatherConditionsDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(CrashReport model, WeatherConditionList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.WeatherConditionsDescription = null;
			}
		}
	}
}