using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class ClearWorkZoneCircumstanceDescriptionIfNotRequired : CrashReportBusinessRuleBase
	{
		public ClearWorkZoneCircumstanceDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.WorkZoneCircumstance))
		{
		}

		protected override void ApplyRule(CrashReport model, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (model.WorkZoneCircumstance == null || !model.WorkZoneCircumstance.RequiresDescription)
			{
				model.WorkZoneCircumstanceDescription = null;
			}
		}
	}
}