using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class ClearWorkZoneTypeDescriptionIfNotRequired : CrashReportBusinessRuleBase
	{
		public ClearWorkZoneTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.WorkZoneType))
		{
		}

		protected override void ApplyRule(CrashReport model, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (model.WorkZoneType == null || !model.WorkZoneType.RequiresDescription)
			{
				model.WorkZoneTypeDescription = null;
			}
		}
	}
}