using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class ClearAlcoholTestTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<ConditionInfo>
	{
		public ClearAlcoholTestTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(ConditionInfo.AlcoholTestType))
		{
		}

		protected override void ApplyRule(ConditionInfo model, ReferenceDataFilter referenceData)
		{
			if (model.AlcoholTestType == null || !model.AlcoholTestType.RequiresDescription)
			{
				model.AlcoholTestTypeDescription = null;
			}
		}
	}
}