using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class ClearBloodAlcoholContentIfNotRequired : CrashReportChildBusinessRuleBase<ConditionInfo>
	{
		public ClearBloodAlcoholContentIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(ConditionInfo.AlcoholTestResult))
		{
		}

		protected override void ApplyRule(ConditionInfo model, ReferenceDataFilter referenceData)
		{
			if (model.AlcoholTestResult == null || !model.AlcoholTestResult.IsBloodAlcoholContentRequired)
			{
				model.BloodAlcoholContent = null;
			}
		}
	}
}