using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class ClearConditionsDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<ConditionInfo, ConditionList, Condition>
	{
		public ClearConditionsDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(ConditionInfo model, ConditionList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.ConditionsDescription = null;
			}
		}
	}
}