using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class ClearDistractionActionDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<ConditionInfo>
	{
		public ClearDistractionActionDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(ConditionInfo.DistractionAction))
		{
		}

		protected override void ApplyRule(ConditionInfo model, ReferenceDataFilter referenceData)
		{
			if (model.DistractionAction == null || !model.DistractionAction.RequiresDescription)
			{
				model.DistractionActionDescription = null;
			}
		}
	}
}