using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class ClearDistractionSourceDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<ConditionInfo>
	{
		public ClearDistractionSourceDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(ConditionInfo.DistractionSource))
		{
		}

		protected override void ApplyRule(ConditionInfo model, ReferenceDataFilter referenceData)
		{
			if (model.DistractionSource == null || !model.DistractionSource.RequiresDescription)
			{
				model.DistractionSourceDescription = null;
			}
		}
	}
}