using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class ClearDrugTestResultsDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<ConditionInfo, DrugTestResultList, DrugTestResult>
	{
		public ClearDrugTestResultsDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(ConditionInfo model, DrugTestResultList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.DrugTestResultsDescription = null;
			}
		}
	}
}