using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class ClearDrugTestTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<ConditionInfo>
	{
		public ClearDrugTestTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(ConditionInfo.DrugTestType))
		{
		}

		protected override void ApplyRule(ConditionInfo model, ReferenceDataFilter referenceData)
		{
			if (model.DrugTestType == null || !model.DrugTestType.RequiresDescription)
			{
				model.DrugTestTypeDescription = null;
			}
		}
	}
}