using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class SetAlcoholTestFieldsBasedOnAlcoholTestStatus : CrashReportChildBusinessRuleBase<ConditionInfo>
	{
		public SetAlcoholTestFieldsBasedOnAlcoholTestStatus(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(ConditionInfo.AlcoholTestStatus))
		{
		}

		protected override void ApplyRule(ConditionInfo model, ReferenceDataFilter referenceData)
		{
			if (model.AlcoholTestStatus == null) return;
			
			if (model.AlcoholTestStatus.IsNo || model.AlcoholTestStatus.IsUnknown)
			{
				model.AlcoholTestType = referenceData.GetNotApplicable<AlcoholTestType>();
				model.AlcoholTestResult = referenceData.GetNotApplicable<AlcoholTestResult>();
				model.IsAlcoholKitNumberUnknown = model.AlcoholTestStatus.IsUnknown;
				model.AlcoholKitNumber = null;
			}
			else
			{
				if (model.AlcoholTestType?.IsNotApplicable == true)
				{
					model.AlcoholTestType = null;
				}
				if (model.AlcoholTestResult?.IsNotApplicable == true)
				{
					model.AlcoholTestResult = null;
				}
			}
		}
	}
}