using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class SetAlcoholTestStatusBasedOnAlcoholUseSuspicion : CrashReportChildBusinessRuleBase<ConditionInfo>
	{
		public SetAlcoholTestStatusBasedOnAlcoholUseSuspicion(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(ConditionInfo.AlcoholUseSuspicion))
		{
		}

		protected override void ApplyRule(ConditionInfo model, ReferenceDataFilter referenceData)
		{
			if (model.AlcoholUseSuspicion?.IsUnknown == true && model.AlcoholTestStatus == null)
			{
				model.AlcoholTestStatus = referenceData.GetFirstOrDefault<AlcoholTestStatus>(x => x.IsNo && !x.TestRefused);
			}
		}
	}
}