﻿using System;
using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class SetDistractionSourceBasedOnDistractionAction : CrashReportChildBusinessRuleBase<ConditionInfo>
	{
		public SetDistractionSourceBasedOnDistractionAction(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(ConditionInfo.DistractionAction))
		{
		}

		protected override void ApplyRule(ConditionInfo model, ReferenceDataFilter referenceData)
		{
			if (model.DistractionAction?.IsNo == true)
			{
				model.DistractionSource = referenceData.GetNotApplicable<DistractionSource>();
			}

			if (model.DistractionAction?.IsInattentive == true)
			{
				model.DistractionSource = referenceData.GetNotApplicable<DistractionSource>();
			}

			if (model.DistractionAction?.IsInattentive == true)
			{
				model.DistractionSource = referenceData.GetNotApplicable<DistractionSource>();
			}
		}
	}
}