using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class SetDrugTestFieldsBasedOnDrugTestStatus : CrashReportChildBusinessRuleBase<ConditionInfo>
	{
		public SetDrugTestFieldsBasedOnDrugTestStatus(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(ConditionInfo.DrugTestStatus))
		{
		}

		protected override void ApplyRule(ConditionInfo model, ReferenceDataFilter referenceData)
		{
			if (model.DrugTestStatus == null) return;
			
			if (model.DrugTestStatus.IsNo)
			{
				model.DrugTestType = referenceData.GetNotApplicable<DrugTestType>();
				model.DrugTestResults.Clear();
				model.DrugTestResults.Add(referenceData.GetNotApplicable<DrugTestResult>());
				model.IsDrugKitNumberUnknown = false;
				model.DrugKitNumber = null;
			}
			else if (model.DrugTestStatus.IsUnknown)
			{
				model.DrugTestType = referenceData.GetUnknown<DrugTestType>();
				model.DrugTestResults.Clear();
				model.DrugTestResults.Add(referenceData.GetUnknown<DrugTestResult>());
				model.IsDrugKitNumberUnknown = true;
				model.DrugKitNumber = null;
			}
			else
			{
				if (model.DrugTestType?.IsNotApplicable == true)
				{
					model.DrugTestType = null;
				}
				if (model.DrugTestResults.Contains(referenceData.GetNotApplicable<DrugTestResult>()))
				{
					model.DrugTestResults.Clear();
				}
			}
		}
	}
}