using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConditionInfoRules
{
	public class SetDrugTestStatusBasedOnDrugUseSuspicion : CrashReportChildBusinessRuleBase<ConditionInfo>
	{
		public SetDrugTestStatusBasedOnDrugUseSuspicion(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(ConditionInfo.DrugUseSuspicion))
		{
		}

		protected override void ApplyRule(ConditionInfo model, ReferenceDataFilter referenceData)
		{
			if (model.DrugUseSuspicion?.IsUnknown == true && model.DrugTestStatus == null)
			{
				model.DrugTestStatus = referenceData.GetFirstOrDefault<DrugTestStatus>(x => x.IsNo && !x.TestRefused);
			}
		}
	}
}