using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConductorRules
{
	public class ClearEmsResponseAgencyDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Conductor>
	{
		public ClearEmsResponseAgencyDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Conductor.EmsResponseAgency))
		{
		}

		protected override void ApplyRule(Conductor model, ReferenceDataFilter referenceData)
		{
			if (model.EmsResponseAgency == null || !model.EmsResponseAgency.RequiresDescription)
			{
				model.EmsResponseAgencyDescription = null;
			}
		}
	}
}