using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConductorRules
{
	public class ClearIncidentResponderDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Conductor>
	{
		public ClearIncidentResponderDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Conductor.IncidentResponder))
		{
		}

		protected override void ApplyRule(Conductor model, ReferenceDataFilter referenceData)
		{
			if (model.IncidentResponder == null || !model.IncidentResponder.RequiresDescription)
			{
				model.IncidentResponderDescription = null;
			}
		}
	}
}