using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConductorRules
{
	public class ClearMedicalFacilityReceivingPatientDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Conductor>
	{
		public ClearMedicalFacilityReceivingPatientDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Conductor.MedicalFacilityReceivingPatient))
		{
		}

		protected override void ApplyRule(Conductor model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalFacilityReceivingPatient == null || !model.MedicalFacilityReceivingPatient.RequiresDescription)
			{
				model.MedicalFacilityReceivingPatientDescription = null;
			}
		}
	}
}