using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.ConductorRules
{
	public class ClearMedicalTransportationTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Conductor>
	{
		public ClearMedicalTransportationTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Conductor.MedicalTransportationType))
		{
		}

		protected override void ApplyRule(Conductor model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalTransportationType == null || !model.MedicalTransportationType.RequiresDescription)
			{
				model.MedicalTransportationTypeDescription = null;
			}
		}
	}
}