using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearAddressStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearAddressStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.AddressState))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.AddressState == null || !model.AddressState.RequiresDescription)
			{
				model.AddressStateDescription = null;
			}
		}
	}
}