using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearAvoidanceManeuverDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearAvoidanceManeuverDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.AvoidanceManeuver))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.AvoidanceManeuver == null || !model.AvoidanceManeuver.RequiresDescription)
			{
				model.AvoidanceManeuverDescription = null;
			}
		}
	}
}