using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearDriverActionsDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<Driver, DriverActionList, DriverAction>
	{
		public ClearDriverActionsDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(Driver model, DriverActionList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.DriverActionsDescription = null;
			}
		}
	}
}