using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearDriverLicenseEndorsementsDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<Driver, DriverLicenseEndorsementList, DriverLicenseEndorsement>
	{
		public ClearDriverLicenseEndorsementsDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(Driver model, DriverLicenseEndorsementList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.DriverLicenseEndorsementsDescription = null;
			}
		}
	}
}