using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearDriverLicenseRestrictionsDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<Driver, DriverLicenseRestrictionList, DriverLicenseRestriction>
	{
		public ClearDriverLicenseRestrictionsDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(Driver model, DriverLicenseRestrictionList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.DriverLicenseRestrictionsDescription = null;
			}
		}
	}
}