using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearDriverLicenseStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearDriverLicenseStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.DriverLicenseState))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.DriverLicenseState == null || !model.DriverLicenseState.RequiresDescription)
			{
				model.DriverLicenseStateDescription = null;
			}
		}
	}
}