﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearEmsResponseRunNumberIfUnknown : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearEmsResponseRunNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.IsEmsResponseRunNumberUnknown))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.IsEmsResponseRunNumberUnknown)
			{
				model.EmsResponseRunNumber = null;
			}
		}
	}
}