using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearIncidentResponderDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearIncidentResponderDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.IncidentResponder))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.IncidentResponder == null || !model.IncidentResponder.RequiresDescription)
			{
				model.IncidentResponderDescription = null;
			}
		}
	}
}