using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearMedicalFacilityReceivingPatientDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearMedicalFacilityReceivingPatientDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.MedicalFacilityReceivingPatient))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalFacilityReceivingPatient == null || !model.MedicalFacilityReceivingPatient.RequiresDescription)
			{
				model.MedicalFacilityReceivingPatientDescription = null;
			}
		}
	}
}