using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearMedicalTransportationTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearMedicalTransportationTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.MedicalTransportationType))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalTransportationType == null || !model.MedicalTransportationType.RequiresDescription)
			{
				model.MedicalTransportationTypeDescription = null;
			}
		}
	}
}