using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearPreCollisionStabilityDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearPreCollisionStabilityDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.PreCollisionStability))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.PreCollisionStability == null || !model.PreCollisionStability.RequiresDescription)
			{
				model.PreCollisionStabilityDescription = null;
			}
		}
	}
}