using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearRaceDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearRaceDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.Race))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.Race == null || !model.Race.RequiresDescription)
			{
				model.RaceDescription = null;
			}
		}
	}
}