using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearRestraintSystemTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearRestraintSystemTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.RestraintSystemType))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.RestraintSystemType == null || !model.RestraintSystemType.RequiresDescription)
			{
				model.RestraintSystemTypeDescription = null;
			}
		}
	}
}