using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class ClearVisionObscurementDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Driver>
	{
		public ClearVisionObscurementDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.VisionObscurement))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.VisionObscurement == null || !model.VisionObscurement.RequiresDescription)
			{
				model.VisionObscurementDescription = null;
			}
		}
	}
}