﻿using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class SetAlcoholInterlockPresenceBasedOnDriverLicenseRestrictions : CrashReportValueCollectionBusinessRuleBase<Driver, DriverLicenseRestrictionList, DriverLicenseRestriction>
	{
		public SetAlcoholInterlockPresenceBasedOnDriverLicenseRestrictions(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(Driver model, DriverLicenseRestrictionList collection, ReferenceDataFilter referenceData)
		{
			if (collection.Count == 0) return;

			bool hasAlcoholInterlockDeviceRestriction = collection.Any(x => x.IsAlcoholInterlockDevice);
			if (hasAlcoholInterlockDeviceRestriction && model.AlcoholInterlockPresence != null && model.AlcoholInterlockPresence.IsNotApplicable)
			{
				model.AlcoholInterlockPresence = null;
			}
			else if (!hasAlcoholInterlockDeviceRestriction)
			{
				model.AlcoholInterlockPresence = referenceData.GetNotApplicable<AlcoholInterlockPresence>();
			}
		}
	}
}