﻿using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.DriverRules
{
	public class SetCommercialDriverLicenseStatusBasedOnDriverLicenseType : CrashReportChildBusinessRuleBase<Driver>
	{
		public SetCommercialDriverLicenseStatusBasedOnDriverLicenseType(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Driver.DriverLicenseType))
		{
		}

		protected override void ApplyRule(Driver model, ReferenceDataFilter referenceData)
		{
			if (model.DriverLicenseType == null) return;
			if (!model.DriverLicenseType.IsCommercial)
			{
				model.CommercialDriverLicenseStatus = referenceData.GetNotApplicable<CommercialDriverLicenseStatus>();
			}
			else if (model.DriverLicenseType.IsCommercial && model.CommercialDriverLicenseStatus != null && model.CommercialDriverLicenseStatus.IsNotApplicable)
			{
				model.CommercialDriverLicenseStatus = null;
			}
		}
	}
}