﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.EngineerRules
{
	public class ClearCertificationNumberIfUnknown : CrashReportChildBusinessRuleBase<Engineer>
	{
		public ClearCertificationNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Engineer.IsCertificationNumberUnknown))
		{
		}

		protected override void ApplyRule(Engineer model, ReferenceDataFilter referenceData)
		{
			if (model.IsCertificationNumberUnknown)
			{
				model.CertificationNumber = null;
			}
		}
	}
}