using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.EngineerRules
{
	public class ClearEmsResponseAgencyDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Engineer>
	{
		public ClearEmsResponseAgencyDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Engineer.EmsResponseAgency))
		{
		}

		protected override void ApplyRule(Engineer model, ReferenceDataFilter referenceData)
		{
			if (model.EmsResponseAgency == null || !model.EmsResponseAgency.RequiresDescription)
			{
				model.EmsResponseAgencyDescription = null;
			}
		}
	}
}