﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.EngineerRules
{
	public class ClearEmsResponseRunNumberIfUnknown : CrashReportChildBusinessRuleBase<Engineer>
	{
		public ClearEmsResponseRunNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Engineer.IsEmsResponseRunNumberUnknown))
		{
		}

		protected override void ApplyRule(Engineer model, ReferenceDataFilter referenceData)
		{
			if (model.IsEmsResponseRunNumberUnknown)
			{
				model.EmsResponseRunNumber = null;
			}
		}
	}
}