using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.EngineerRules
{
	public class ClearMedicalFacilityReceivingPatientDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Engineer>
	{
		public ClearMedicalFacilityReceivingPatientDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Engineer.MedicalFacilityReceivingPatient))
		{
		}

		protected override void ApplyRule(Engineer model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalFacilityReceivingPatient == null || !model.MedicalFacilityReceivingPatient.RequiresDescription)
			{
				model.MedicalFacilityReceivingPatientDescription = null;
			}
		}
	}
}