using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.EngineerRules
{
	public class ClearMedicalTransportationTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Engineer>
	{
		public ClearMedicalTransportationTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Engineer.MedicalTransportationType))
		{
		}

		protected override void ApplyRule(Engineer model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalTransportationType == null || !model.MedicalTransportationType.RequiresDescription)
			{
				model.MedicalTransportationTypeDescription = null;
			}
		}
	}
}