using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.EngineerRules
{
	public class ClearRaceDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Engineer>
	{
		public ClearRaceDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Engineer.Race))
		{
		}

		protected override void ApplyRule(Engineer model, ReferenceDataFilter referenceData)
		{
			if (model.Race == null || !model.Race.RequiresDescription)
			{
				model.RaceDescription = null;
			}
		}
	}
}