using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearActionPriorToCrashDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<NonMotorist>
	{
		public ClearActionPriorToCrashDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonMotorist.ActionPriorToCrash))
		{
		}

		protected override void ApplyRule(NonMotorist model, ReferenceDataFilter referenceData)
		{
			if (model.ActionPriorToCrash == null || !model.ActionPriorToCrash.RequiresDescription)
			{
				model.ActionPriorToCrashDescription = null;
			}
		}
	}
}