using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearContributingCircumstancesDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<NonMotorist, NonMotoristContributingCircumstanceList, NonMotoristContributingCircumstance>
	{
		public ClearContributingCircumstancesDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(NonMotorist model, NonMotoristContributingCircumstanceList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.ContributingCircumstancesDescription = null;
			}
		}
	}
}