using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearEmsResponseAgencyDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<NonMotorist>
	{
		public ClearEmsResponseAgencyDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonMotorist.EmsResponseAgency))
		{
		}

		protected override void ApplyRule(NonMotorist model, ReferenceDataFilter referenceData)
		{
			if (model.EmsResponseAgency == null || !model.EmsResponseAgency.RequiresDescription)
			{
				model.EmsResponseAgencyDescription = null;
			}
		}
	}
}