﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearEmsResponseRunNumberIfUnknown : CrashReportChildBusinessRuleBase<NonMotorist>
	{
		public ClearEmsResponseRunNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonMotorist.IsEmsResponseRunNumberUnknown))
		{
		}

		protected override void ApplyRule(NonMotorist model, ReferenceDataFilter referenceData)
		{
			if (model.IsEmsResponseRunNumberUnknown)
			{
				model.EmsResponseRunNumber = null;
			}
		}
	}
}