using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearIncidentResponderDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<NonMotorist>
	{
		public ClearIncidentResponderDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonMotorist.IncidentResponder))
		{
		}

		protected override void ApplyRule(NonMotorist model, ReferenceDataFilter referenceData)
		{
			if (model.IncidentResponder == null || !model.IncidentResponder.RequiresDescription)
			{
				model.IncidentResponderDescription = null;
			}
		}
	}
}