using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearLocationDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<NonMotorist>
	{
		public ClearLocationDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonMotorist.Location))
		{
		}

		protected override void ApplyRule(NonMotorist model, ReferenceDataFilter referenceData)
		{
			if (model.Location == null || !model.Location.RequiresDescription)
			{
				model.LocationDescription = null;
			}
		}
	}
}