using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearMedicalFacilityReceivingPatientDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<NonMotorist>
	{
		public ClearMedicalFacilityReceivingPatientDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonMotorist.MedicalFacilityReceivingPatient))
		{
		}

		protected override void ApplyRule(NonMotorist model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalFacilityReceivingPatient == null || !model.MedicalFacilityReceivingPatient.RequiresDescription)
			{
				model.MedicalFacilityReceivingPatientDescription = null;
			}
		}
	}
}