using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearMedicalTransportationTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<NonMotorist>
	{
		public ClearMedicalTransportationTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonMotorist.MedicalTransportationType))
		{
		}

		protected override void ApplyRule(NonMotorist model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalTransportationType == null || !model.MedicalTransportationType.RequiresDescription)
			{
				model.MedicalTransportationTypeDescription = null;
			}
		}
	}
}