using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearRaceDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<NonMotorist>
	{
		public ClearRaceDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonMotorist.Race))
		{
		}

		protected override void ApplyRule(NonMotorist model, ReferenceDataFilter referenceData)
		{
			if (model.Race == null || !model.Race.RequiresDescription)
			{
				model.RaceDescription = null;
			}
		}
	}
}