using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearSafetyEquipmentDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<NonMotorist, NonMotoristSafetyEquipmentList, NonMotoristSafetyEquipment>
	{
		public ClearSafetyEquipmentDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(NonMotorist model, NonMotoristSafetyEquipmentList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.SafetyEquipmentDescription = null;
			}
		}
	}
}