﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.Document.BusinessRules;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearStrikingVehicleIdWhenVehicleIsRemoved : DocumentBusinessRuleBase<CrashReport>
	{
		public ClearStrikingVehicleIdWhenVehicleIsRemoved(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void OnNodeDetached(CrashReport document, IDocumentNode<CrashReport> node, ReferenceDataFilter referenceData)
		{
			if (node is Vehicle vehicle)
			{
				foreach (var nonMotorist in document.NonMotorists)
				{
					if (nonMotorist.StrikingVehicleId == vehicle.NodeId)
					{
						nonMotorist.StrikingVehicleId = null;
					}
				}
			}
		}
	}
}