using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonMotoristRules
{
	public class ClearTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<NonMotorist>
	{
		public ClearTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonMotorist.Type))
		{
		}

		protected override void ApplyRule(NonMotorist model, ReferenceDataFilter referenceData)
		{
			if (model.Type == null || !model.Type.RequiresDescription)
			{
				model.TypeDescription = null;
			}
		}
	}
}