﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonVehicularPropertyRules
{
	public class ClearOwnerAddressIfNotApplicable : CrashReportChildBusinessRuleBase<NonVehicularProperty>
	{
		public ClearOwnerAddressIfNotApplicable(IReferenceDataCache referenceDataCache) 
			: base(referenceDataCache, nameof(NonVehicularProperty.IsOwnerAddressUnknown))
		{
		}

		protected override void ApplyRule(NonVehicularProperty model, ReferenceDataFilter referenceData)
		{
			if (model.IsOwnerAddressUnknown)
			{
				model.OwnerAddressStreet = null;
				model.OwnerAddressCity = null;
				model.OwnerAddressState = null;
				model.OwnerAddressStateDescription = null;
				model.OwnerAddressPostalCode = null;
			}
		}
	}
}