using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonVehicularPropertyRules
{
	public class ClearOwnerAddressStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<NonVehicularProperty>
	{
		public ClearOwnerAddressStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonVehicularProperty.OwnerAddressState))
		{
		}

		protected override void ApplyRule(NonVehicularProperty model, ReferenceDataFilter referenceData)
		{
			if (model.OwnerAddressState == null || !model.OwnerAddressState.RequiresDescription)
			{
				model.OwnerAddressStateDescription = null;
			}
		}
	}
}