﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonVehicularPropertyRules
{
	public class ClearOwnerNameIfNotRequired : CrashReportChildBusinessRuleBase<NonVehicularProperty>
	{
		public ClearOwnerNameIfNotRequired(IReferenceDataCache referenceDataCache) 
			: base(referenceDataCache, nameof(NonVehicularProperty.IsOwnerNameUnknown))
		{
		}

		protected override void ApplyRule(NonVehicularProperty model, ReferenceDataFilter referenceData)
		{
			if (model.IsOwnerNameUnknown)
			{
				model.OwnerName = null;
			}
		}
	}
}