﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonVehicularPropertyRules
{
	public class ClearOwnerPhoneNumberIfNotRequired : CrashReportChildBusinessRuleBase<NonVehicularProperty>
	{
		public ClearOwnerPhoneNumberIfNotRequired(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(NonVehicularProperty.IsOwnerPhoneNumberUnknown))
		{
		}

		protected override void ApplyRule(NonVehicularProperty model, ReferenceDataFilter referenceData)
		{
			if (model.IsOwnerPhoneNumberUnknown)
			{
				model.OwnerPhoneNumber = null;
			}
		}
	}
}