using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.NonVehicularPropertyRules
{
	public class ClearPropertyTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<NonVehicularProperty>
	{
		public ClearPropertyTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(NonVehicularProperty.PropertyType))
		{
		}

		protected override void ApplyRule(NonVehicularProperty model, ReferenceDataFilter referenceData)
		{
			if (model.PropertyType == null || !model.PropertyType.RequiresDescription)
			{
				model.PropertyTypeDescription = null;
			}
		}
	}
}