﻿using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.OccupantRules
{
	public class SetImproperRestraintSystemUsageToUnknownWhenRestraintSystemTypeIsUnknown : CrashReportChildBusinessRuleBase<Occupant>
	{
		public SetImproperRestraintSystemUsageToUnknownWhenRestraintSystemTypeIsUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Occupant.RestraintSystemType))
		{
		}

		protected override void ApplyRule(Occupant model, ReferenceDataFilter referenceData)
		{
			if (model.RestraintSystemType != null && model.RestraintSystemType.IsUnknown && model.ImproperRestraintSystemUsage == null)
			{
				model.ImproperRestraintSystemUsage = referenceData.GetUnknown<ImproperRestraintSystemUsage>();
			}
		}
	}
}