﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearAddressIfUnknown : CrashReportChildBusinessRuleBase<Passenger>
	{
		public ClearAddressIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Person.IsAddressUnknown))
		{
		}

		protected override void ApplyRule(Passenger model, ReferenceDataFilter referenceData)
		{
			if (model.IsAddressUnknown)
			{
				model.AddressStreet = null;
				model.AddressCity = null;
				model.AddressState = null;
				model.AddressStateDescription = null;
				model.AddressPostalCode = null;
			}
		}
	}
}