using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearAddressStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Passenger>
	{
		public ClearAddressStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Passenger.AddressState))
		{
		}

		protected override void ApplyRule(Passenger model, ReferenceDataFilter referenceData)
		{
			if (model.AddressState == null || !model.AddressState.RequiresDescription)
			{
				model.AddressStateDescription = null;
			}
		}
	}
}