using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearAirBagDeploymentsDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<Passenger, AirBagDeploymentList, AirBagDeployment>
	{
		public ClearAirBagDeploymentsDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(Passenger model, AirBagDeploymentList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.AirBagDeploymentsDescription = null;
			}
		}
	}
}