using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearEmsResponseAgencyDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Passenger>
	{
		public ClearEmsResponseAgencyDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Passenger.EmsResponseAgency))
		{
		}

		protected override void ApplyRule(Passenger model, ReferenceDataFilter referenceData)
		{
			if (model.EmsResponseAgency == null || !model.EmsResponseAgency.RequiresDescription)
			{
				model.EmsResponseAgencyDescription = null;
			}
		}
	}
}