﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearEmsResponseRunNumberIfUnknown : CrashReportChildBusinessRuleBase<Passenger>
	{
		public ClearEmsResponseRunNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Passenger.IsEmsResponseRunNumberUnknown))
		{
		}

		protected override void ApplyRule(Passenger model, ReferenceDataFilter referenceData)
		{
			if (model.IsEmsResponseRunNumberUnknown)
			{
				model.EmsResponseRunNumber = null;
			}
		}
	}
}