using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearIncidentResponderDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Passenger>
	{
		public ClearIncidentResponderDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Passenger.IncidentResponder))
		{
		}

		protected override void ApplyRule(Passenger model, ReferenceDataFilter referenceData)
		{
			if (model.IncidentResponder == null || !model.IncidentResponder.RequiresDescription)
			{
				model.IncidentResponderDescription = null;
			}
		}
	}
}