using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearMedicalFacilityReceivingPatientDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Passenger>
	{
		public ClearMedicalFacilityReceivingPatientDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Passenger.MedicalFacilityReceivingPatient))
		{
		}

		protected override void ApplyRule(Passenger model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalFacilityReceivingPatient == null || !model.MedicalFacilityReceivingPatient.RequiresDescription)
			{
				model.MedicalFacilityReceivingPatientDescription = null;
			}
		}
	}
}