using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearMedicalTransportationTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Passenger>
	{
		public ClearMedicalTransportationTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Passenger.MedicalTransportationType))
		{
		}

		protected override void ApplyRule(Passenger model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalTransportationType == null || !model.MedicalTransportationType.RequiresDescription)
			{
				model.MedicalTransportationTypeDescription = null;
			}
		}
	}
}