﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearNameIfUnknown : CrashReportChildBusinessRuleBase<Passenger>
	{
		public ClearNameIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Person.IsNameUnknown))
		{
		}

		protected override void ApplyRule(Passenger model, ReferenceDataFilter referenceData)
		{
			if (model.IsNameUnknown)
			{
				model.FirstName = null;
				model.MiddleName = null;
				model.LastName = null;
				model.NameSuffix = null;
			}
		}
	}
}