using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearRaceDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Passenger>
	{
		public ClearRaceDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Passenger.Race))
		{
		}

		protected override void ApplyRule(Passenger model, ReferenceDataFilter referenceData)
		{
			if (model.Race == null || !model.Race.RequiresDescription)
			{
				model.RaceDescription = null;
			}
		}
	}
}