using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PassengerRules
{
	public class ClearRestraintSystemTypeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Passenger>
	{
		public ClearRestraintSystemTypeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Passenger.RestraintSystemType))
		{
		}

		protected override void ApplyRule(Passenger model, ReferenceDataFilter referenceData)
		{
			if (model.RestraintSystemType == null || !model.RestraintSystemType.RequiresDescription)
			{
				model.RestraintSystemTypeDescription = null;
			}
		}
	}
}