﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PersonRules
{
	public abstract class ClearAgeIfUnknownBase<T> : CrashReportChildBusinessRuleBase<T> where T : Person
	{
		protected ClearAgeIfUnknownBase(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Person.IsAgeUnknown))
		{
		}

		protected override void ApplyRule(T model, ReferenceDataFilter referenceData)
		{
			if (model.IsAgeUnknown && model.Age != null)
			{
				model.Age = null;
			}
		}
	}
}