﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PersonRules
{
	public abstract class ClearDateOfBirthIfUnknownBase<T> : CrashReportChildBusinessRuleBase<T> where T : Person
	{
		protected ClearDateOfBirthIfUnknownBase(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Person.IsDateOfBirthUnknown))
		{
		}

		protected override void ApplyRule(T model, ReferenceDataFilter referenceData)
		{
			if (model.IsDateOfBirthUnknown && model.DateOfBirth != null)
			{
				model.DateOfBirth = null;
			}
		}
	}
}