﻿using System;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PersonRules
{
	public class ClearMedicalUniqueIdentifierIfNotApplicable : CrashReportChildBusinessRuleBase<Person>
	{
		public ClearMedicalUniqueIdentifierIfNotApplicable(IReferenceDataCache referenceDataCache, params string[] properties) 
			: base(referenceDataCache, nameof(Person.IsMedicalUniqueIdentifierNotApplicable))
		{
		}

		protected override void ApplyRule(Person model, ReferenceDataFilter referenceData)
		{
			if (model.IsMedicalUniqueIdentifierNotApplicable)
			{
				model.IsMedicalUniqueIdentifierUnknown = false;
				model.MedicalUniqueIdentifier = null;
			}
		}
	}
}