﻿using System;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PersonRules
{
	public class ClearMedicalUniqueIdentifierIfUnknown : CrashReportChildBusinessRuleBase<Person>
	{
		public ClearMedicalUniqueIdentifierIfUnknown(IReferenceDataCache referenceDataCache, params string[] properties) 
			: base(referenceDataCache, nameof(Person.IsMedicalUniqueIdentifierUnknown))
		{
		}

		protected override void ApplyRule(Person model, ReferenceDataFilter referenceData)
		{
			if (model.IsMedicalUniqueIdentifierUnknown)
			{
				model.IsMedicalUniqueIdentifierNotApplicable = false;
				model.MedicalUniqueIdentifier = null;
			}
		}
	}
}