﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PersonRules
{
	public abstract class SetIsAgeUnknownToFalseWhenAgeIsNotNullBase<T> : CrashReportChildBusinessRuleBase<T> where T : Person
	{
		protected SetIsAgeUnknownToFalseWhenAgeIsNotNullBase(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Person.Age))
		{
		}

		protected override void ApplyRule(T model, ReferenceDataFilter referenceData)
		{
			if (model.Age != null && model.IsAgeUnknown)
			{
				model.IsAgeUnknown = false;
			}
		}
	}
}