﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PersonRules
{
	public abstract class SetIsDateOfBirthUnknownToFalseWhenDateOfBirthIsNotNullBase<T> : CrashReportChildBusinessRuleBase<T> where T : Person
	{
		protected SetIsDateOfBirthUnknownToFalseWhenDateOfBirthIsNotNullBase(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Person.DateOfBirth))
		{
		}

		protected override void ApplyRule(T model, ReferenceDataFilter referenceData)
		{
			if (model.DateOfBirth != null && model.IsDateOfBirthUnknown)
			{
				model.IsDateOfBirthUnknown = false;
			}
		}
	}
}