﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.PersonRules
{
	public class SetMedicalUniqueIdentifierFieldsBasedOnMedicalTransportationType : CrashReportChildBusinessRuleBase<Person>
	{
		public SetMedicalUniqueIdentifierFieldsBasedOnMedicalTransportationType(IReferenceDataCache referenceDataCache, params string[] properties) 
			: base(referenceDataCache, nameof(Person.MedicalTransportationType))
		{
		}

		protected override void ApplyRule(Person model, ReferenceDataFilter referenceData)
		{
			if (model.MedicalTransportationType == null) return;

			if (model.MedicalUniqueIdentifier == null && !model.IsMedicalUniqueIdentifierNotApplicable && !model.IsMedicalUniqueIdentifierUnknown)
			{
				if (model.MedicalTransportationType.IsNo)
				{
					model.IsMedicalUniqueIdentifierNotApplicable = true;
				}
			}
		}
	}
}