﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class SetDefaultValueForIsDistanceFromIntersectionNotApplicable : CrashReportBusinessRuleBase
	{
		public SetDefaultValueForIsDistanceFromIntersectionNotApplicable(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(CrashReport.IsIntersection), nameof(CrashReport.RoadClassification))
		{
		}

		protected override void ApplyRule(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			// If a distance has already been entered, don't clear it
			if (document.DistanceFromIntersection != null) return;

			// Default IsDistanceFromIntersectionNotApplicable to true on intersection and private property crashes
			bool isPrivateProperty = document.RoadClassification?.IsPrivate == true;
			document.IsDistanceFromIntersectionNotApplicable = document.IsIntersection || isPrivateProperty;
		}
	}
}