﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class SetDirectionFromIntersectionBasedOnIsDistanceFromIntersectionNotApplicable : CrashReportBusinessRuleBase
	{
		public SetDirectionFromIntersectionBasedOnIsDistanceFromIntersectionNotApplicable(IReferenceDataCache referenceDataCache) 
			: base(referenceDataCache, nameof(CrashReport.IsDistanceFromIntersectionNotApplicable))
		{
		}

		protected override void ApplyRule(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (document.IsDistanceFromIntersectionNotApplicable)
			{
				document.DirectionFromIntersection = referenceData.GetNotApplicable<DirectionFromIntersection>();
			}
			else if (document.DirectionFromIntersection is { IsNotApplicable: true })
			{
				document.DirectionFromIntersection = null;
			}
		}
	}
}