﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class SetIntersectionFieldsBasedOnIntersectionApproach : CrashReportBusinessRuleBase
	{
		public SetIntersectionFieldsBasedOnIntersectionApproach(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(IntersectionApproach))
		{
		}

		protected override void ApplyRule(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (document.IntersectionApproach == null || document.IntersectionApproach.IsYes)
			{
				if (document.IntersectionGeometry?.IsNotApplicable == true) document.IntersectionGeometry = null;
				if (document.IntersectionTrafficControl?.IsNotApplicable == true) document.IntersectionTrafficControl = null;
			}
			else if (document.IntersectionApproach.IsNo)
			{
				document.IntersectionGeometry = referenceData.GetNotApplicable<IntersectionGeometry>();
				document.IntersectionTrafficControl = referenceData.GetNotApplicable<IntersectionTrafficControl>();
			}
		}
	}
}