﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class SetOnSceneInvestigationCompletionDateToMatchPoliceArrivalDate : CrashReportBusinessRuleBase
	{
		public SetOnSceneInvestigationCompletionDateToMatchPoliceArrivalDate(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.PoliceArrivalDate))
		{
		}

		protected override void ApplyRule(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (document.OnSceneInvestigationCompletionDate == null || document.OnSceneInvestigationCompletionTime == null)
			{
				document.OnSceneInvestigationCompletionDate = document.PoliceArrivalDate;
			}
		}
	}
}