﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class SetPoliceArrivalDateToMatchPoliceNotificationDate : CrashReportBusinessRuleBase
	{
		public SetPoliceArrivalDateToMatchPoliceNotificationDate(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.PoliceNotificationDate))
		{
		}

		protected override void ApplyRule(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (document.PoliceArrivalDate == null || document.PoliceArrivalTime == null)
			{
				document.PoliceArrivalDate = document.PoliceNotificationDate;
			}
		}
	}
}