﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class SetPoliceNotificationDateToMatchCrashDate : CrashReportBusinessRuleBase
	{
		public SetPoliceNotificationDateToMatchCrashDate(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.CrashDate))
		{
		}

		protected override void ApplyRule(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (document.PoliceNotificationDate == null || document.PoliceNotificationTime == null)
			{
				document.PoliceNotificationDate = document.CrashDate;
			}
		}
	}
}