﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class SetRoadSubtypeBasedOnRoadClassification : CrashReportBusinessRuleBase
	{
		public SetRoadSubtypeBasedOnRoadClassification(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.RoadClassification))
		{
		}

		protected override void ApplyRule(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			bool isRoad = document.RoadClassification == null || document.RoadClassification.IsRoad;
			bool isNotApplicable = document.RoadSubtype?.IsNotApplicable == true;
			if (isRoad && isNotApplicable)
			{
				document.RoadSubtype = null;
			}
			else if (!isRoad && !isNotApplicable)
			{
				document.RoadSubtype = referenceData.GetNotApplicable<RoadSubtype>();
			}
		}
	}
}