﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class SetRoadwayClearanceDateToMatchCrashDate : CrashReportBusinessRuleBase
	{
		public SetRoadwayClearanceDateToMatchCrashDate(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.CrashDate))
		{
		}

		protected override void ApplyRule(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (document.RoadwayClearanceDate == null || document.RoadwayClearanceTime == null)
			{
				document.RoadwayClearanceDate = document.CrashDate;
			}
		}
	}
}