﻿using System;
using ECrash.Core.Models;
using ECrash.Core.Models.Document;
using ECrash.Core.Models.Document.BusinessRules;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class SetUpdateTimestampOnChange : DocumentBusinessRuleBase<CrashReport>
	{
		public SetUpdateTimestampOnChange(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void OnPropertyChangeCore(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			if (change.IsExplicitlyFor(nameof(CrashReport.UpdateTimestamp))) return;
			document.UpdateTimestamp = DateTime.Now;
		}

		protected override void OnCollectionChangeCore(CrashReport document, ReferenceDataFilter referenceData, DocumentCollectionChangedEventArgs change)
		{
			document.UpdateTimestamp = DateTime.Now;
		}
	}
}