﻿using System;
using System.Linq;
using System.Security.Cryptography.X509Certificates;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class SetWorkZoneRelationBasedOnRoadwayEnvironmentalContributingCircumstances : CrashReportValueCollectionBusinessRuleBase<CrashReport, RoadwayEnvironmentalContributingCircumstanceList, RoadwayEnvironmentalContributingCircumstance>
	{
		public SetWorkZoneRelationBasedOnRoadwayEnvironmentalContributingCircumstances(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache)
		{
		}

		protected override void ApplyRule(CrashReport document, RoadwayEnvironmentalContributingCircumstanceList collection, ReferenceDataFilter referenceData)
		{
			if (collection.Any(x => x.IsWorkZone) && (document.WorkZoneRelation == null || !document.WorkZoneRelation.IsYes))
			{
				document.WorkZoneRelation = referenceData.GetFirstOrDefault<WorkZoneRelation>(v => v.IsYes);
			}
		}
	}
}