using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainPassengerRules
{
	public class ClearAddressStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<TrainPassenger>
	{
		public ClearAddressStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(TrainPassenger.AddressState))
		{
		}

		protected override void ApplyRule(TrainPassenger model, ReferenceDataFilter referenceData)
		{
			if (model.AddressState == null || !model.AddressState.RequiresDescription)
			{
				model.AddressStateDescription = null;
			}
		}
	}
}