using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainPassengerRules
{
	public class ClearEmsResponseAgencyDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<TrainPassenger>
	{
		public ClearEmsResponseAgencyDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(TrainPassenger.EmsResponseAgency))
		{
		}

		protected override void ApplyRule(TrainPassenger model, ReferenceDataFilter referenceData)
		{
			if (model.EmsResponseAgency == null || !model.EmsResponseAgency.RequiresDescription)
			{
				model.EmsResponseAgencyDescription = null;
			}
		}
	}
}