﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainPassengerRules
{
	public class ClearEmsResponseRunNumberIfUnknown : CrashReportChildBusinessRuleBase<TrainPassenger>
	{
		public ClearEmsResponseRunNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(TrainPassenger.IsEmsResponseRunNumberUnknown))
		{
		}

		protected override void ApplyRule(TrainPassenger model, ReferenceDataFilter referenceData)
		{
			if (model.IsEmsResponseRunNumberUnknown)
			{
				model.EmsResponseRunNumber = null;
			}
		}
	}
}