using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainPassengerRules
{
	public class ClearIncidentResponderDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<TrainPassenger>
	{
		public ClearIncidentResponderDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(TrainPassenger.IncidentResponder))
		{
		}

		protected override void ApplyRule(TrainPassenger model, ReferenceDataFilter referenceData)
		{
			if (model.IncidentResponder == null || !model.IncidentResponder.RequiresDescription)
			{
				model.IncidentResponderDescription = null;
			}
		}
	}
}