﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainPassengerRules
{
	public class ClearPhoneNumberIfUnknown : CrashReportChildBusinessRuleBase<TrainPassenger>
	{
		public ClearPhoneNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Person.IsPhoneNumberUnknown))
		{
		}

		protected override void ApplyRule(TrainPassenger model, ReferenceDataFilter referenceData)
		{
			if (model.IsPhoneNumberUnknown)
			{
				model.PhoneNumber = null;
			}
		}
	}
}