using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainPassengerRules
{
	public class ClearRaceDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<TrainPassenger>
	{
		public ClearRaceDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(TrainPassenger.Race))
		{
		}

		protected override void ApplyRule(TrainPassenger model, ReferenceDataFilter referenceData)
		{
			if (model.Race == null || !model.Race.RequiresDescription)
			{
				model.RaceDescription = null;
			}
		}
	}
}