﻿using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearActiveWarningDeviceStatusesDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<Train, TrainActiveWarningDeviceStatusList, TrainActiveWarningDeviceStatus>
	{
		public ClearActiveWarningDeviceStatusesDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(Train model, TrainActiveWarningDeviceStatusList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.ActiveWarningDeviceStatusesDescription = null;
			}
		}
	}
}