﻿using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearAdvanceWarningDevicesDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<Train, TrainAdvanceWarningDeviceList, TrainAdvanceWarningDevice>
	{
		public ClearAdvanceWarningDevicesDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(Train model, TrainAdvanceWarningDeviceList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.AdvanceWarningDevicesDescription = null;
			}
		}
	}
}