﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearCrossingSurfaceMaterialDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearCrossingSurfaceMaterialDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.CrossingSurfaceMaterial))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.CrossingSurfaceMaterial == null || !model.CrossingSurfaceMaterial.RequiresDescription)
			{
				model.CrossingSurfaceMaterialDescription = null;
			}
		}
	}
}