﻿using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearDataRecorderSpeedIfNotEquipped : CrashReportValueCollectionBusinessRuleBase<Train, TrainEquipmentStatusList, TrainEquipmentStatus>
	{
		public ClearDataRecorderSpeedIfNotEquipped(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(Train model, TrainEquipmentStatusList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.IsEventDataRecorderEquipped))
			{
				model.DataRecorderSpeed = null;
				model.IsDataRecorderSpeedPending = false;
			}
		}
	}
}