﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearDataRecorderSpeedIfPending : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearDataRecorderSpeedIfPending(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsDataRecorderSpeedPending))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsDataRecorderSpeedPending)
			{
				model.DataRecorderSpeed = null;
			}
		}
	}
}