﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearDistanceTraveledAfterImpactIfNotApplicable : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearDistanceTraveledAfterImpactIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsDistanceTraveledAfterImpactNotApplicable))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsDistanceTraveledAfterImpactNotApplicable)
			{
				model.DistanceTraveledAfterImpact = null;
				model.DistanceTraveledAfterImpactUnit = null;
			}
		}
	}
}