﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearDotCrossingNumberIfNotApplicable : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearDotCrossingNumberIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsDotCrossingNumberNotApplicable))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsDotCrossingNumberNotApplicable)
			{
				model.DotCrossingNumber = null;
				model.IsDotCrossingNumberUnknown = false;
			}
		}
	}
}