﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearDotCrossingNumberIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearDotCrossingNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsDotCrossingNumberUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsDotCrossingNumberUnknown)
			{
				model.DotCrossingNumber = null;
				model.IsDotCrossingNumberNotApplicable = false;
			}
		}
	}
}