﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearHazardousMaterialsIdIfNotApplicable : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearHazardousMaterialsIdIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsHazardousMaterialsIdNotApplicable))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsHazardousMaterialsIdNotApplicable)
			{
				model.IsHazardousMaterialsIdUnknown = false;
				model.HazardousMaterialsId = null;
			}
		}
	}
}