﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearHazardousMaterialsIdIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearHazardousMaterialsIdIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsHazardousMaterialsIdUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsHazardousMaterialsIdUnknown)
			{
				model.IsHazardousMaterialsIdNotApplicable = false;
				model.HazardousMaterialsId = null;
			}
		}
	}
}