﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearLeadEngineNumberIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearLeadEngineNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsLeadEngineNumberUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsLeadEngineNumberUnknown)
			{
				model.LeadEngineNumber = null;
			}
		}
	}
}