﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearNumberOfCarsIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearNumberOfCarsIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsNumberOfCarsUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsNumberOfCarsUnknown)
			{
				model.NumberOfCars = null;
			}
		}
	}
}