﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearNumberOfEnginesIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearNumberOfEnginesIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsNumberOfEnginesUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsNumberOfEnginesUnknown)
			{
				model.NumberOfEngines = null;
			}
		}
	}
}