﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearOperatorAddressIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearOperatorAddressIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsOperatorAddressUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsOperatorAddressUnknown)
			{
				model.OperatorAddressStreet = null;
				model.OperatorAddressCity = null;
				model.OperatorAddressState = null;
				model.OperatorAddressStateDescription = null;
				model.OperatorAddressPostalCode = null;
			}
		}
	}
}