using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearOperatorAddressStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearOperatorAddressStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.OperatorAddressState))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.OperatorAddressState == null || !model.OperatorAddressState.RequiresDescription)
			{
				model.OperatorAddressStateDescription = null;
			}
		}
	}
}