﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearOperatorNameIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearOperatorNameIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsOperatorNameUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsOperatorNameUnknown)
			{
				model.OperatorName = null;
			}
		}
	}
}