﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearSerialNumberIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearSerialNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsSerialNumberUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsSerialNumberUnknown)
			{
				model.SerialNumber = null;
			}
		}
	}
}