﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearStruckCarNumberIfNotApplicable : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearStruckCarNumberIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsStruckCarNumberNotApplicable))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsStruckCarNumberNotApplicable)
			{
				model.StruckCarNumber = null;
				model.IsStruckCarNumberUnknown = false;
			}
		}
	}
}