﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearStruckCarNumberIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearStruckCarNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsStruckCarNumberUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsStruckCarNumberUnknown)
			{
				model.StruckCarNumber = null;
				model.IsStruckCarNumberNotApplicable = false;
			}
		}
	}
}