﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearStruckCarPositionIfNotApplicable : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearStruckCarPositionIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsStruckCarPositionNotApplicable))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsStruckCarPositionNotApplicable)
			{
				model.StruckCarPosition = null;
				model.IsStruckCarPositionUnknown = false;
			}
		}
	}
}