﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearStruckCarPositionIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearStruckCarPositionIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsStruckCarPositionUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsStruckCarPositionUnknown)
			{
				model.StruckCarPosition = null;
				model.IsStruckCarPositionNotApplicable = false;
			}
		}
	}
}