﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearStruckCarTypeIfNotApplicable : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearStruckCarTypeIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsStruckCarTypeNotApplicable))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsStruckCarTypeNotApplicable)
			{
				model.StruckCarType = null;
				model.IsStruckCarTypeUnknown = false;
			}
		}
	}
}