﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearStruckCarTypeIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearStruckCarTypeIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsStruckCarTypeUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsStruckCarTypeUnknown)
			{
				model.StruckCarType = null;
				model.IsStruckCarTypeNotApplicable = false;
			}
		}
	}
}