﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearTrackOwnerAddressIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearTrackOwnerAddressIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsTrackOwnerAddressUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsTrackOwnerAddressUnknown)
			{
				model.TrackOwnerAddressStreet = null;
				model.TrackOwnerAddressCity = null;
				model.TrackOwnerAddressState = null;
				model.TrackOwnerAddressStateDescription = null;
				model.TrackOwnerAddressPostalCode = null;
			}
		}
	}
}