using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearTrackOwnerAddressStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearTrackOwnerAddressStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.TrackOwnerAddressState))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.TrackOwnerAddressState == null || !model.TrackOwnerAddressState.RequiresDescription)
			{
				model.TrackOwnerAddressStateDescription = null;
			}
		}
	}
}