﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearTrackOwnerNameIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearTrackOwnerNameIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsTrackOwnerNameUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsTrackOwnerNameUnknown)
			{
				model.TrackOwnerName = null;
			}
		}
	}
}