﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearTrainIdNumberIfNotApplicable : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearTrainIdNumberIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsTrainIdNumberNotApplicable))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsTrainIdNumberNotApplicable)
			{
				model.IsTrainIdNumberUnknown = false;
				model.TrainIdNumber = null;
			}
		}
	}
}