﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearTrainIdNumberIfUnknown : CrashReportChildBusinessRuleBase<Train>
	{
		public ClearTrainIdNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsTrainIdNumberUnknown))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsTrainIdNumberUnknown)
			{
				model.IsTrainIdNumberNotApplicable = false;
				model.TrainIdNumber = null;
			}
		}
	}
}