﻿using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class ClearWarningDevicesDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<Train, TrainWarningDeviceList, TrainWarningDevice>
	{
		public ClearWarningDevicesDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override void ApplyRule(Train model, TrainWarningDeviceList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.WarningDevicesDescription = null;
			}
		}
	}
}