﻿using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.TrainRules
{
	public class SetHazardousMaterialClassBasedOnHazardousMaterialsId : CrashReportChildBusinessRuleBase<Train>
	{
		public SetHazardousMaterialClassBasedOnHazardousMaterialsId(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Train.IsHazardousMaterialsIdNotApplicable))
		{
		}

		protected override void ApplyRule(Train model, ReferenceDataFilter referenceData)
		{
			if (model.IsHazardousMaterialsIdNotApplicable)
			{
				model.HazardousMaterialClass = referenceData.GetNotApplicable<HazardousMaterialClass>();
			}
			else if (model.HazardousMaterialClass?.IsNotApplicable == true)
			{
				model.HazardousMaterialClass = null;
			}
		}
	}
}