﻿using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules
{
	public class TrimLocalCaseNumber : CrashReportBusinessRuleBase
	{
		public TrimLocalCaseNumber(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(CrashReport.LocalCaseNumber))
		{
		}

		protected override void OnInitializeCore(CrashReport document, ReferenceDataFilter referenceData)
		{
			ApplyRule(document, referenceData, null);
		}

		protected override void ApplyRule(CrashReport document, ReferenceDataFilter referenceData, DocumentPropertyChangedEventArgs change)
		{
			document.LocalCaseNumber = document.LocalCaseNumber?.Trim();
		}
	}
}