﻿using ECrash.Core.Models;
using ECrash.Core.Models.Document;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRegistrationRules
{
	public class ClearTagFieldsIfTagMissing : CrashReportChildBusinessRuleBase<IHasVehicleRegistration>
	{
		public ClearTagFieldsIfTagMissing(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(IHasVehicleRegistration.IsTagMissing))
		{
		}

		protected override void ApplyRule(IHasVehicleRegistration model, ReferenceDataFilter referenceData)
		{
			if (model != null && model.IsTagMissing)
			{
				if (model is Vehicle vehicle)
				{
					vehicle.TagYear = null;
					vehicle.IsTagYearUnknown = false;
				}
				model.TagState = null;
				model.IsTagStateUnknown = false;
				model.TagNumber = null;
				model.IsTagNumberUnknown = false;
			}
		}
	}
}