﻿using System;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRegistrationRules
{
	public class ClearTagNumberIfUnknown : CrashReportChildBusinessRuleBase<IHasVehicleRegistration>
	{
		public ClearTagNumberIfUnknown(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(IHasVehicleRegistration.IsTagNumberUnknown))
		{
		}

		protected override void ApplyRule(IHasVehicleRegistration model, ReferenceDataFilter referenceData)
		{
			if (model != null && model.IsTagNumberUnknown)
			{
				model.TagNumber = null;
			}
		}
	}
}