﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRegistrationRules
{
	public class ClearTagStateIfUnknown : CrashReportChildBusinessRuleBase<IHasVehicleRegistration>
	{
		public ClearTagStateIfUnknown(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(IHasVehicleRegistration.IsTagStateUnknown))
		{
		}

		protected override void ApplyRule(IHasVehicleRegistration model, ReferenceDataFilter referenceData)
		{
			if (model != null && model.IsTagStateUnknown)
			{
				model.TagState = null;
			}
		}
	}
}