﻿using System;
using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRegistrationRules
{
	public class ClearVinIfUnknown : CrashReportChildBusinessRuleBase<IHasVehicleRegistration>
	{
		public ClearVinIfUnknown(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(IHasVehicleRegistration.IsVinUnknown))
		{
		}

		protected override void ApplyRule(IHasVehicleRegistration model, ReferenceDataFilter referenceData)
		{
			if (model != null && model.IsVinUnknown)
			{
				model.Vin = null;
			}
		}
	}
}