﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearCommodityHauledIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearCommodityHauledIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsCommodityHauledUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsCommodityHauledUnknown)
			{
				model.CommodityHauled = null;
			}
		}
	}
}