using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearContributingCircumstanceDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearContributingCircumstanceDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.ContributingCircumstance))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.ContributingCircumstance == null || !model.ContributingCircumstance.RequiresDescription)
			{
				model.ContributingCircumstanceDescription = null;
			}
		}
	}
}