﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearDistanceTraveledAfterImpactIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearDistanceTraveledAfterImpactIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsDistanceTraveledAfterImpactUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsDistanceTraveledAfterImpactUnknown)
			{
				model.DistanceTraveledAfterImpact = null;
			}
		}
	}
}