﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearHazardousMaterialsIdIfNotApplicable : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearHazardousMaterialsIdIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsHazardousMaterialsIdNotApplicable))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsHazardousMaterialsIdNotApplicable)
			{
				model.IsHazardousMaterialsIdUnknown = false;
				model.HazardousMaterialsId = null;
			}
		}
	}
}