﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearHazardousMaterialsIdIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearHazardousMaterialsIdIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsHazardousMaterialsIdUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsHazardousMaterialsIdUnknown)
			{
				model.IsHazardousMaterialsIdNotApplicable = false;
				model.HazardousMaterialsId = null;
			}
		}
	}
}