﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearLiabilityInsuranceCompanyIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearLiabilityInsuranceCompanyIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsLiabilityInsuranceCompanyUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsLiabilityInsuranceCompanyUnknown)
			{
				model.LiabilityInsuranceCompany = null;
			}
		}
	}
}