﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearLiabilityInsuranceCompanyPhoneNumberIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearLiabilityInsuranceCompanyPhoneNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsLiabilityInsuranceCompanyPhoneNumberUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsLiabilityInsuranceCompanyPhoneNumberUnknown)
			{
				model.LiabilityInsuranceCompanyPhoneNumber = null;
			}
		}
	}
}