﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearLiabilityInsuranceFieldsIfIsUninsured : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearLiabilityInsuranceFieldsIfIsUninsured(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsUninsured))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsUninsured)
			{
				model.IsLiabilityInsuranceCompanyUnknown = false;
				model.LiabilityInsuranceCompany = null;
				model.IsLiabilityInsuranceCompanyPhoneNumberUnknown = false;
				model.LiabilityInsuranceCompanyPhoneNumber = null;
				model.IsLiabilityInsuranceNaicNumberUnknown = false;
				model.LiabilityInsuranceNaicNumber = null;
				model.IsLiabilityInsurancePolicyNumberUnknown = false;
				model.LiabilityInsurancePolicyNumber = null;
				model.IsLiabilityInsurancePolicyExpirationDateUnknown = false;
				model.LiabilityInsurancePolicyExpirationDate = null;
			}
		}
	}
}