﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearLiabilityInsuranceNaicNumberIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearLiabilityInsuranceNaicNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsLiabilityInsuranceNaicNumberUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsLiabilityInsuranceNaicNumberUnknown)
			{
				model.LiabilityInsuranceNaicNumber = null;
			}
		}
	}
}