﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearLiabilityInsurancePolicyExpirationDateIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearLiabilityInsurancePolicyExpirationDateIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsLiabilityInsurancePolicyExpirationDateUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsLiabilityInsurancePolicyExpirationDateUnknown)
			{
				model.LiabilityInsurancePolicyExpirationDate = null;
			}
		}
	}
}