﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearLiabilityInsurancePolicyNumberIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearLiabilityInsurancePolicyNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsLiabilityInsurancePolicyNumberUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsLiabilityInsurancePolicyNumberUnknown)
			{
				model.LiabilityInsurancePolicyNumber = null;
			}
		}
	}
}