using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearMakeDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearMakeDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.Make))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.Make == null || !model.Make.RequiresDescription)
			{
				model.MakeDescription = null;
			}
		}
	}
}