﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearModelYearIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearModelYearIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsModelYearUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsModelYearUnknown)
			{
				model.ModelYear = null;
			}
		}
	}
}