﻿using System;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules;

public class ClearMotorCarrierAddressIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
{
	public ClearMotorCarrierAddressIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsMotorCarrierAddressUnknown))
	{
	}

	protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
	{
		if (model.IsMotorCarrierAddressUnknown)
		{
			model.MotorCarrierAddressStreet = null;
			model.MotorCarrierAddressCity = null;
			model.MotorCarrierAddressState = null;
			model.MotorCarrierAddressPostalCode = null;
		}
	}
}