using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearMotorCarrierIdentificationNumberIfNotRequired : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearMotorCarrierIdentificationNumberIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.MotorCarrierIdentificationType))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.MotorCarrierIdentificationType == null || !model.MotorCarrierIdentificationType.RequiresIdentificationNumber)
			{
				model.MotorCarrierIdentificationNumber = null;
			}
		}
	}
}