using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearMotorCarrierIdentificationStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearMotorCarrierIdentificationStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.MotorCarrierIdentificationState))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.MotorCarrierIdentificationState == null || !model.MotorCarrierIdentificationState.RequiresDescription)
			{
				model.MotorCarrierIdentificationStateDescription = null;
			}
		}
	}
}