using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearMotorCarrierIdentificationStateIfNotRequired : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearMotorCarrierIdentificationStateIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.MotorCarrierIdentificationType))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.MotorCarrierIdentificationType == null || !model.MotorCarrierIdentificationType.RequiresIdentificationState)
			{
				model.MotorCarrierIdentificationState = null;
			}
		}
	}
}