﻿using System;
using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearMotorCarrierInformationIfNotAMotorCarrier : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearMotorCarrierInformationIfNotAMotorCarrier(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Vehicle.MotorCarrierType))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.MotorCarrierType?.IsNo == true)
			{
				model.IsMotorCarrierNameUnknown = false;
				model.MotorCarrierName = null;
				model.IsMotorCarrierAddressUnknown = false;
				model.MotorCarrierAddressStreet = null;
				model.MotorCarrierAddressCity = null;
				model.MotorCarrierAddressState = null;
				model.MotorCarrierAddressStateDescription = null;
				model.MotorCarrierAddressPostalCode = null;
			}
		}
	}
}