﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules;

public class ClearMotorCarrierNameIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
{
	public ClearMotorCarrierNameIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsMotorCarrierNameUnknown))
	{
	}

	protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
	{
		if (model.IsMotorCarrierNameUnknown)
		{
			model.MotorCarrierName = null;
		}
	}
}