﻿using System;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules;

public class ClearMotorCarrierPhoneNumberIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
{
	public ClearMotorCarrierPhoneNumberIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsMotorCarrierPhoneNumberUnknown))
	{
	}

	protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
	{
		if (model.IsMotorCarrierPhoneNumberUnknown)
		{
			model.MotorCarrierPhoneNumber = null;
		}
	}
}