﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearNumberOfAxlesIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearNumberOfAxlesIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsNumberOfAxlesUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsNumberOfAxlesUnknown)
			{
				model.NumberOfAxles = null;
			}
		}
	}
}