﻿using System;
using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearOccupantRestraintSystemTypesIfVehicleBodyTypeChangesToMotorcycle : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearOccupantRestraintSystemTypesIfVehicleBodyTypeChangesToMotorcycle(IReferenceDataCache referenceDataCache, params string[] properties) 
			: base(referenceDataCache, nameof(Vehicle.BodyType))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.BodyType?.IsMotorcycle == true)
			{
				if (model.Driver?.RestraintSystemType != null && !model.Driver.RestraintSystemType.IsMotorcycle)
				{
					model.Driver.RestraintSystemType = null;
				}

				if (model.Passengers != null && model.Passengers.Count != 0)
				{
					foreach (var modelPassenger in model.Passengers)
					{
						if (modelPassenger.RestraintSystemType != null && !modelPassenger.RestraintSystemType.IsMotorcycle)
						{
							modelPassenger.RestraintSystemType = null;
						}
					}
				}
			}
		}
	}
}