using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearOwnerAddressStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearOwnerAddressStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.OwnerAddressState))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.OwnerAddressState == null || !model.OwnerAddressState.RequiresDescription)
			{
				model.OwnerAddressStateDescription = null;
			}
		}
	}
}