﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearOwnerNameIfNotRequired : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearOwnerNameIfNotRequired(IReferenceDataCache referenceDataCache) 
			: base(referenceDataCache, nameof(Vehicle.IsOwnerNameUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsOwnerNameUnknown)
			{
				model.OwnerName = null;
			}
		}
	}
}