﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearSkidmarkFieldsIfNotApplicable : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearSkidmarkFieldsIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsSkidmarkLengthNotApplicable))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsSkidmarkLengthNotApplicable)
			{
				model.IsSkidmarkLengthUnknown = false;
				model.SkidmarkLengthFrontLeft = null;
				model.SkidmarkLengthFrontRight = null;
				model.SkidmarkLengthRearLeft = null;
				model.SkidmarkLengthRearRight = null;
			}
		}
	}
}