﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearSkidmarkFieldsIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearSkidmarkFieldsIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsSkidmarkLengthUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsSkidmarkLengthUnknown)
			{
				model.IsSkidmarkLengthNotApplicable = false;
				model.SkidmarkLengthFrontLeft = null;
				model.SkidmarkLengthFrontRight = null;
				model.SkidmarkLengthRearLeft = null;
				model.SkidmarkLengthRearRight = null;
			}
		}
	}
}