﻿using System;
using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearSpeedLimitIfNotApplicable : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearSpeedLimitIfNotApplicable(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Vehicle.IsSpeedLimitNotApplicable))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsSpeedLimitNotApplicable)
			{
				model.SpeedLimit = null;
			}
		}
	}
}