﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearTagYearIfNonExpiring : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearTagYearIfNonExpiring(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Vehicle.IsTagNonExpiring))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsTagNonExpiring)
			{
				model.TagYear = null;
				model.IsTagYearUnknown = false;
			}
		}
	}
}