﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearTagYearIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearTagYearIfUnknown(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Vehicle.IsTagYearUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsTagYearUnknown)
			{
				model.TagYear = null;
				model.IsTagNonExpiring = false;
			}
		}
	}
}