using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearTowServiceIfUnknown : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearTowServiceIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.IsTowServiceUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsTowServiceUnknown)
			{
				model.TowService = null;
			}
		}
	}
}