using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearTrafficControlDevicesInoperativeOrMissingDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<Vehicle, TrafficControlDeviceTypeList, TrafficControlDeviceType>
	{
		public ClearTrafficControlDevicesInoperativeOrMissingDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override bool ShouldApplyRule(Vehicle model, TrafficControlDeviceTypeList collection)
		{
			return base.ShouldApplyRule(model, collection) && collection == model.TrafficControlDevicesInoperativeOrMissing;
		}

		protected override void ApplyRule(Vehicle model, TrafficControlDeviceTypeList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.TrafficControlDevicesInoperativeOrMissingDescription = null;
			}
		}
	}
}