using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearTrafficControlDevicesPresentDescriptionIfNotRequired : CrashReportValueCollectionBusinessRuleBase<Vehicle, TrafficControlDeviceTypeList, TrafficControlDeviceType>
	{
		public ClearTrafficControlDevicesPresentDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache)
		{
		}

		protected override bool ShouldApplyRule(Vehicle model, TrafficControlDeviceTypeList collection)
		{
			return base.ShouldApplyRule(model, collection) && collection == model.TrafficControlDevicesPresent;
		}

		protected override void ApplyRule(Vehicle model, TrafficControlDeviceTypeList collection, ReferenceDataFilter referenceData)
		{
			if (!collection.Any(x => x.RequiresDescription))
			{
				model.TrafficControlDevicesPresentDescription = null;
			}
		}
	}
}