using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearVehicleUsageDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearVehicleUsageDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.VehicleUsage))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.VehicleUsage == null || !model.VehicleUsage.RequiresDescription)
			{
				model.VehicleUsageDescription = null;
			}
		}
	}
}