﻿using System;
using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class ClearWeightRatingIfVehicleConfigurationIsNotConsistent : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public ClearWeightRatingIfVehicleConfigurationIsNotConsistent(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Vehicle.VehicleConfiguration))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.VehicleConfiguration == null || model.WeightRating == null) return;

			if (model.VehicleConfiguration.IsWeight10kOrBelow && (model.WeightRating.IsMediumWeight || model.WeightRating.IsHeavyWeight || model.WeightRating.IsNotApplicable))
			{
				model.WeightRating = null;
				return;
			}

			if (model.VehicleConfiguration.IsWeightAbove10k && (model.WeightRating.IsLightWeight || model.WeightRating.IsNotApplicable))
			{
				model.WeightRating = null;
			}
		}
	}
}