﻿using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetCargoBodyTypeIfVehicleConfigurationIsBus : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetCargoBodyTypeIfVehicleConfigurationIsBus(IReferenceDataCache referenceDataCache) 
			: base(referenceDataCache, nameof(Vehicle.VehicleConfiguration))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model?.VehicleConfiguration == null) return;

			if (model.VehicleConfiguration.IsBus)
			{
				model.CargoBodyType = referenceData.GetFirst<CargoBodyType>(x => x.IsBus);
			}
		}
	}
}