﻿using System;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules;

public class SetEmergencyVehicleUsageBasedOnVehicleUsage : CrashReportChildBusinessRuleBase<Vehicle>
{
	public SetEmergencyVehicleUsageBasedOnVehicleUsage(IReferenceDataCache referenceDataCache, params string[] properties) 
		: base(referenceDataCache, nameof(Vehicle.VehicleUsage))
	{
	}

	protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
	{
		if (model.VehicleUsage?.IsNo == true)
		{
			model.EmergencyVehicleUsage = referenceData.GetNotApplicable<EmergencyVehicleUsage>();
		}
	}
}