﻿using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetHazardousMaterialClassBasedOnHazardousMaterialsId : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetHazardousMaterialClassBasedOnHazardousMaterialsId(IReferenceDataCache referenceDataCache) 
			: base(referenceDataCache, nameof(Vehicle.IsHazardousMaterialsIdNotApplicable))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.IsHazardousMaterialsIdNotApplicable)
			{
				model.HazardousMaterialClass = referenceData.GetNotApplicable<HazardousMaterialClass>();
			}
			else if (model.HazardousMaterialClass?.IsNotApplicable == true)
			{
				model.HazardousMaterialClass = null;
			}
		}
	}
}