﻿using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetHazardousMaterialFieldsBasedOnHazardousMaterialsPlacardStatus : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetHazardousMaterialFieldsBasedOnHazardousMaterialsPlacardStatus(IReferenceDataCache referenceDataCache) 
			: base(referenceDataCache, nameof(Vehicle.HazardousMaterialsPlacardStatus))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model?.HazardousMaterialsPlacardStatus == null) return;

			switch (model.HazardousMaterialsPlacardStatus.HadPlacard)
			{
				case false:
					model.IsHazardousMaterialsIdNotApplicable = true;
					model.HazardousMaterialClass = referenceData.GetNotApplicable<HazardousMaterialClass>();
					break;
				case true:
					model.IsHazardousMaterialsIdNotApplicable = false;
					if (model.HazardousMaterialClass?.IsNotApplicable == true) model.HazardousMaterialClass = null;
					break;
			}

			switch (model.HazardousMaterialsPlacardStatus.HadHazardousMaterials)
			{
				case false:
					model.HazardousMaterialRelease = referenceData.GetNotApplicable<HazardousMaterialRelease>();
					break;
				case true:
					// clearing field for input
					if (model.HazardousMaterialRelease?.IsNotApplicable == true) model.HazardousMaterialRelease = null;
					break;
			}
		}
	}
}