﻿using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetLicensePlateTypeBasedOnIsTagMissing : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetLicensePlateTypeBasedOnIsTagMissing(IReferenceDataCache referenceDataCache, params string[] properties) 
			: base(referenceDataCache, nameof(Vehicle.IsTagMissing))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model == null) return;
			if (model.IsTagMissing == true)
			{
				model.LicensePlateType = referenceData.GetNotApplicable<LicensePlateType>();
			}
			else
			{
				model.LicensePlateType = null;
			}
		}
	}
}