﻿using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetLicensePlateTypeBasedOnTagState : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetLicensePlateTypeBasedOnTagState(IReferenceDataCache referenceDataCache, params string[] properties)
			: base(referenceDataCache, nameof(Vehicle.TagState), nameof(Vehicle.IsTagStateUnknown))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model == null || model.IsTagMissing) return;

			if (model.IsTagStateUnknown)
			{
				model.LicensePlateType = referenceData.GetUnknown<LicensePlateType>();
			}
			else
			{
				if (model.TagState == null || model.TagState.Code == "LA")
				{
					model.LicensePlateType = null;
				}
				else
				{
					model.LicensePlateType = referenceData.GetFirst<LicensePlateType>(x => x.IsOutOfState);
				}
			}
		}
	}
}