﻿using System;
using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetMotorCarrierIdentificationTypeBasedOnMotorCarrierType : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetMotorCarrierIdentificationTypeBasedOnMotorCarrierType(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Vehicle.MotorCarrierType))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.MotorCarrierType?.IsNo == true && (model.MotorCarrierIdentificationType == null || model.MotorCarrierIdentificationType.IsNotApplicable == false))
			{
				model.MotorCarrierIdentificationType = referenceData.GetFirstOrDefault<MotorCarrierIdentificationType>(x => x.IsNotApplicable);
			}
		}
	}
}