﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetNumberOfAxlesBasedOnVehicleConfiguration : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetNumberOfAxlesBasedOnVehicleConfiguration(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Vehicle.VehicleConfiguration))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.VehicleConfiguration?.HasTwoAxles == true)
			{
				model.IsNumberOfAxlesUnknown = false;
				model.NumberOfAxles = 2;
			}
		}
	}
}