using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetTowFieldsBasedOnTowStatus : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetTowFieldsBasedOnTowStatus(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Vehicle.TowStatus))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.TowStatus == null || !model.TowStatus.IsYes)
			{
				model.TowService = null;
				model.IsTowServiceUnknown = false;
				model.TowAuthority = referenceData.GetNotApplicable<TowAuthority>();
				model.TowAuthorityDescription = null;
			}
			else if (model.TowAuthority != null && model.TowAuthority.IsNotApplicable)
			{
				model.TowAuthority = null;
			}
		}
	}
}