﻿using System;
using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetTrafficwayBarrierTypeToNoBarrierIfTrafficwayDivisionIsNotDivided : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetTrafficwayBarrierTypeToNoBarrierIfTrafficwayDivisionIsNotDivided(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Vehicle.TrafficwayDivision))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model?.TrafficwayDivision != null && model.TrafficwayDivision.IsNo && (model.TrafficwayBarrierType == null || !model.TrafficwayBarrierType.IsNo))
			{
				model.TrafficwayBarrierType = referenceData.GetFirstOrDefault<TrafficwayBarrierType>(b => b.IsNo);
			}
		}
	}
}