﻿using System;
using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetTrafficwayDivisionToNotDividedIfTrafficwayTravelDirectionIsOneWay : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetTrafficwayDivisionToNotDividedIfTrafficwayTravelDirectionIsOneWay(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Vehicle.TrafficwayTravelDirection))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model?.TrafficwayTravelDirection != null && model.TrafficwayTravelDirection.IsOneWay && (model.TrafficwayDivision == null || !model.TrafficwayDivision.IsDefaultForOneWay))
			{
				model.TrafficwayDivision = referenceData.GetFirstOrDefault<TrafficwayDivision>(d => d.IsDefaultForOneWay);
			}
		}
	}
}