﻿using System;
using System.Linq;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleRules
{
	public class SetTrafficwayHovLaneRelationBasedOnTrafficwayHovLanePresence : CrashReportChildBusinessRuleBase<Vehicle>
	{
		public SetTrafficwayHovLaneRelationBasedOnTrafficwayHovLanePresence(IReferenceDataCache referenceDataCache)
			: base(referenceDataCache, nameof(Vehicle.TrafficwayHovLanePresence))
		{
		}

		protected override void ApplyRule(Vehicle model, ReferenceDataFilter referenceData)
		{
			if (model.TrafficwayHovLanePresence != null && model.TrafficwayHovLanePresence.IsNo)
			{
				model.TrafficwayHovLaneRelation = referenceData.GetFirstOrDefault<TrafficwayHovLaneRelation>(d => d.IsNo);
			}
		}
	}
}