using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleTrailerRules
{
	public class ClearModelYearIfUnknown : CrashReportChildBusinessRuleBase<VehicleTrailer>
	{
		public ClearModelYearIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(VehicleTrailer.IsModelYearUnknown))
		{
		}

		protected override void ApplyRule(VehicleTrailer model, ReferenceDataFilter referenceData)
		{
			if (model.IsModelYearUnknown)
			{
				model.ModelYear = null;
			}
		}
	}
}