using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleTrailerRules
{
	public class ClearNumberOfAxlesIfUnknown : CrashReportChildBusinessRuleBase<VehicleTrailer>
	{
		public ClearNumberOfAxlesIfUnknown(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(VehicleTrailer.IsNumberOfAxlesUnknown))
		{
		}

		protected override void ApplyRule(VehicleTrailer model, ReferenceDataFilter referenceData)
		{
			if (model.IsNumberOfAxlesUnknown)
			{
				model.NumberOfAxles = null;
			}
		}
	}
}