using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleTrailerRules
{
	public class ClearTagStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<VehicleTrailer>
	{
		public ClearTagStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(VehicleTrailer.TagState))
		{
		}

		protected override void ApplyRule(VehicleTrailer model, ReferenceDataFilter referenceData)
		{
			if (model.TagState == null || !model.TagState.RequiresDescription)
			{
				model.TagStateDescription = null;
			}
		}
	}
}