﻿using System;
using ECrash.Core.Models.ReferenceData;
using ECrashLA.Core.Models.CrashReports.Validation.Rules;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleTrailerRules
{
	public class ClearTagYearIfNonExpiring : CrashReportChildBusinessRuleBase<VehicleTrailer>
	{
		public ClearTagYearIfNonExpiring(IReferenceDataCache referenceDataCache, params string[] properties) 
			: base(referenceDataCache, nameof(VehicleTrailer.IsTagNonExpiring))
		{
		}

		protected override void ApplyRule(VehicleTrailer model, ReferenceDataFilter referenceData)
		{
			if (model.IsTagNonExpiring)
			{
				model.TagYear = null;
				model.IsTagYearUnknown = false;
			}
		}
	}
}