﻿using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.VehicleTrailerRules
{
	public class ClearTagYearIfUnknown : CrashReportChildBusinessRuleBase<VehicleTrailer>
	{
		public ClearTagYearIfUnknown(IReferenceDataCache referenceDataCache, params string[] properties) 
			: base(referenceDataCache, nameof(VehicleTrailer.IsTagYearUnknown))
		{
		}

		protected override void ApplyRule(VehicleTrailer model, ReferenceDataFilter referenceData)
		{
			if (model.IsTagYearUnknown)
			{
				model.TagYear = null;
				model.IsTagNonExpiring = false;
			}
		}
	}
}