using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.WitnessRules
{
	public class ClearAddressFieldsIfNotApplicable : CrashReportChildBusinessRuleBase<Witness>
	{
		public ClearAddressFieldsIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Witness.IsAddressUnknown))
		{
		}

		protected override void ApplyRule(Witness model, ReferenceDataFilter referenceData)
		{
			if (model.IsAddressUnknown)
			{
				model.AddressStreet = null;
				model.AddressCity = null;
				model.AddressState = null;
				model.AddressStateDescription = null;
				model.AddressPostalCode = null;
			}
		}
	}
}