using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.WitnessRules
{
	public class ClearAddressStateDescriptionIfNotRequired : CrashReportChildBusinessRuleBase<Witness>
	{
		public ClearAddressStateDescriptionIfNotRequired(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Witness.AddressState))
		{
		}

		protected override void ApplyRule(Witness model, ReferenceDataFilter referenceData)
		{
			if (model.AddressState == null || !model.AddressState.RequiresDescription)
			{
				model.AddressStateDescription = null;
			}
		}
	}
}