using ECrash.Core.Models.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports.BusinessRules.WitnessRules
{
	public class ClearAgeIfNotApplicable : CrashReportChildBusinessRuleBase<Witness>
	{
		public ClearAgeIfNotApplicable(IReferenceDataCache referenceDataCache) : base(referenceDataCache, nameof(Witness.IsAgeUnknown))
		{
		}

		protected override void ApplyRule(Witness model, ReferenceDataFilter referenceData)
		{
			if (model.IsAgeUnknown)
			{
				model.Age = null;
			}
		}
	}
}