﻿using System.Collections.Generic;
using ECrash.Core.Models.Document;
using ECrashLA.Core.Models.CrashReports.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports
{
	public class Citation : DocumentChild<CrashReport>, INeedsCollectionIndex
	{
		private string _ticketNumber;
		private ViolationCode _violationCode;
		private string _violationCodeDescription;
		private ViolationCategory _violationCategory;

		public override IEnumerable<IDocumentNode<CrashReport>> EnumerateChildNodes()
		{
			yield break;
		}

		[JsonIgnore]
		public int Index => (Parent as CitationList)?.IndexOf(this) ?? -1;

		[JsonIgnore]
		public int Number => Index + 1;

		[MaxLength(20)]
		public string TicketNumber
		{
			get => _ticketNumber;
			set => Set(ref _ticketNumber, value);
		}

		public ViolationCode ViolationCode
		{
			get => _violationCode;
			set => Set(ref _violationCode, value);
		}

		[MaxLength(200)]
		public string ViolationCodeDescription
		{
			get => _violationCodeDescription;
			set => Set(ref _violationCodeDescription, value);
		}

		public ViolationCategory ViolationCategory
		{
			get => _violationCategory;
			set => Set(ref _violationCategory, value);
		}

		void INeedsCollectionIndex.OnCollectionIndexChanged()
		{
			NotifyOfPropertyChange(nameof(Index));
			NotifyOfPropertyChange(nameof(Number));
		}
	}
}