﻿using System;

namespace ECrashLA.Core.Models.CrashReports
{
	/// <summary>
	/// A set of flags that indicate whether the crash as a whole is reportable to FMCSA, and if so, why.
	/// </summary>
	[Flags]
	public enum CrashFmcsaReportability
	{
		NotReportable                    = 0x00000000, //0
		ReportableDueToFatality          = 0x00000001, //1
		ReportableDueToInjury            = 0x00000002, //2
		ReportableDueToTowaway           = 0x00000004, //4
		HasReportableVehicles            = 0x00010000, //65536
        HasConditionalReportableVehicles = 0x00020000 //131072
    }
}