﻿using System;
using ECrash.Core.Models.Document;

namespace ECrashLA.Core.Models.CrashReports
{
	public class CrashReportStatus : DocumentStatusBase<CrashReportApprovalStatus>
	{
		private string _localCaseReferenceNumber;
		private CrashReportSource _source;

		public CrashReportStatus(Guid id) : base(id)
		{
		}

		public string LocalCaseReferenceNumber
		{
			get => _localCaseReferenceNumber;
			set => Set(ref _localCaseReferenceNumber, value);
		}

		public override bool IsStateCaseNumberValid()
		{
			if (Date == null) throw new InvalidOperationException("Date must not be null");
			return StateCaseNumber != null && Date != null && StateCaseNumber.StartsWith(Date.Value.Year.ToString("0000"));
		}

		public CrashReportSource Source
		{
			get => _source;
			set => Set(ref _source, value);
		}
	}
}