﻿using ECrash.Core.Models.Document;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports
{
	public class Engineer : Person
	{
		private bool _isCertificationNumberUnknown;
		private string _certificationNumber;

		[JsonIgnore]
		public override int Index => (Parent as Train)?.Index ?? -1;

		public bool IsCertificationNumberUnknown
		{
			get => _isCertificationNumberUnknown;
			set => Set(ref _isCertificationNumberUnknown, value);
		}

		[MaxLength(20)]
		public string CertificationNumber
		{
			get => _certificationNumber;
			set => Set(ref _certificationNumber, value);
		}
	}
}