﻿using ECrash.Core.Models.Document;
using ECrashLA.Core.Models.CrashReports.ReferenceData;

namespace ECrashLA.Core.Models.CrashReports
{
	/// <summary>
	/// Provides necessary properties for anything with a license plate.
	/// </summary>
	public interface IHasVehicleRegistration : IDocumentNode<CrashReport>
	{
		bool IsVinUnknown { get; set; }
		[MaxLength(20)] string Vin { get; set; }
		bool IsTagMissing { get; set; }
		bool IsTagStateUnknown { get; set; }
		State TagState { get; set; }
		[MaxLength(200)] string TagStateDescription { get; set; }
		bool IsTagNumberUnknown { get; set; }
		[MaxLength(10)] string TagNumber { get; set; }
		bool IsTagNonExpiring { get; set; }
		bool IsTagYearUnknown { get; set; }
		int? TagYear { get; set; }
	}
}