﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class AlcoholTestResult : ReferenceDataBase
	{
		public const string BloodAlcoholContentRequiredTag = "BloodAlcoholContentRequired";
		public const string PendingTag = "Pending";

		public AlcoholTestResult(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsBloodAlcoholContentRequired
		{
			get => Tags.Contains(BloodAlcoholContentRequiredTag);
			set => SetTagPresence(BloodAlcoholContentRequiredTag, value);
		}

		[JsonIgnore]
		public bool IsPending
		{
			get => Tags.Contains(PendingTag);
			set => SetTagPresence(PendingTag, value);
		}
	}
}