﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class AlcoholTestType : ReferenceDataBase
	{
		public const string FatalTag = "Fatal";
		public const string NonFatalTag = "NonFatal";
		public const string CanHaveActualValueTag = "CanHaveActualValue";

		public AlcoholTestType(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool Fatal
		{
			get => Tags.Contains(FatalTag);
			set => SetTagPresence(FatalTag, value);
		}

		[JsonIgnore]
		public bool NonFatal
		{
			get => Tags.Contains(NonFatalTag);
			set => SetTagPresence(NonFatalTag, value);
		}

		[JsonIgnore]
		public bool CanHaveActualValue
		{
			get => Tags.Contains(CanHaveActualValueTag);
			set => SetTagPresence(CanHaveActualValueTag, value);
		}
	}
}