﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// The type of body for buses and trucks with more than 10k GVWR, as defined by MMUCC field LV9. 
	/// </summary>
	public class CargoBodyType : ReferenceDataBase
	{
		public const string BusTag = "Bus";
		public const string EndorsementRequiredTag = "EndorsementRequired";

		[JsonIgnore]
		public bool IsBus
		{
			get => Tags.Contains(BusTag);
			set => SetTagPresence(BusTag, value);
		}

		[JsonIgnore]
		public bool IsEndorsementRequired
		{
			get => Tags.Contains(EndorsementRequiredTag);
			set => SetTagPresence(EndorsementRequiredTag, value);
		}

		public CargoBodyType(int id, RowVersion version) : base(id, version)
		{
		}
	}
}