﻿using System.Collections.Generic;
using System.Linq;
using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	[HideCodes]
	public class City : ReferenceDataBase
	{
		public const string ParishesField = nameof(Parishes);

		public City(int id, RowVersion version) : base(id, version)
		{
		}

		public bool IsInParish(Parish parish)
		{
			return parish != null && Parishes.Contains(parish.Code);
		}

		[JsonIgnore]
		public IEnumerable<string> Parishes
		{
			get => GetFieldValues<string>(ParishesField);
            set => Fields[ParishesField] = new JArray(value);
        }
    }
}