﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class Condition : ReferenceDataBase
	{
		public const string NormalTag = "Normal";
		public const string InattentiveTag = "Inattentive";
		public const string UnderTheInfluenceTag = "UnderTheInfluence";

		[JsonIgnore]
		public bool IsNormal
		{
			get => Tags.Contains(NormalTag);
			set => SetTagPresence(NormalTag, value);
		}

		[JsonIgnore]
		public bool IsInattentive
		{
			get => Tags.Contains(InattentiveTag);
			set => SetTagPresence(InattentiveTag, value);
		}

		[JsonIgnore]
		public bool IsUnderTheInfluence
		{
			get => Tags.Contains(UnderTheInfluenceTag);
			set => SetTagPresence(UnderTheInfluenceTag, value);
		}

		public Condition(int id, RowVersion version) : base(id, version)
		{
		}
	}
}