﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class ContributingFactor : ReferenceDataBase
	{
		public const string DriverConditionTag = "DriverCondition";
		public const string LightConditionTag = "LightCondition";
		public const string NonMotoristActionTag = "NonMotoristAction";
		public const string NonMotoristConditionTag = "NonMotoristCondition";
		public const string RoadwayConditionTag = "RoadwayCondition";
		public const string RoadSurfaceTag = "RoadSurface";
		public const string TrafficControlTag = "TrafficControl";
		public const string VehicleConditionTag = "VehicleCondition";
		public const string VisionObscurementTag = "VisionObscurement";
		public const string WeatherConditionTag = "WeatherCondition";

		[JsonIgnore]
		public bool IsDriverCondition
		{
			get => Tags.Contains(DriverConditionTag);
			set => SetTagPresence(DriverConditionTag, value);
		}

		[JsonIgnore]
		public bool IsLightCondition
		{
			get => Tags.Contains(LightConditionTag);
			set => SetTagPresence(LightConditionTag, value);
		}

		[JsonIgnore]
		public bool IsNonMotoristAction
		{
			get => Tags.Contains(NonMotoristActionTag);
			set => SetTagPresence(NonMotoristActionTag, value);
		}

		[JsonIgnore]
		public bool IsNonMotoristCondition
		{
			get => Tags.Contains(NonMotoristConditionTag);
			set => SetTagPresence(NonMotoristConditionTag, value);
		}

		[JsonIgnore]
		public bool IsRoadwayCondition
		{
			get => Tags.Contains(RoadwayConditionTag);
			set => SetTagPresence(RoadwayConditionTag, value);
		}

		[JsonIgnore]
		public bool IsRoadSurface
		{
			get => Tags.Contains(RoadSurfaceTag);
			set => SetTagPresence(RoadSurfaceTag, value);
		}

		[JsonIgnore]
		public bool IsVehicleCondition
		{
			get => Tags.Contains(VehicleConditionTag);
			set => SetTagPresence(VehicleConditionTag, value);
		}
		
		[JsonIgnore]
		public bool IsVisionObscurement
		{
			get => Tags.Contains(VisionObscurementTag);
			set => SetTagPresence(VisionObscurementTag, value);
		}

		[JsonIgnore]
		public bool IsWeatherCondition
		{
			get => Tags.Contains(WeatherConditionTag);
			set => SetTagPresence(WeatherConditionTag, value);
		}

		[JsonIgnore]
		public bool IsTrafficControl
		{
			get => Tags.Contains(TrafficControlTag);
			set => SetTagPresence(TrafficControlTag, value);
		}

		public ContributingFactor(int id, RowVersion version) : base(id, version)
		{
		}
	}
}