﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData;

public class CrashMannerDrawing : ReferenceDataBase
{
	// Field definitions
	public const string XamlField = "Xaml";
	public const string SvgField = "Svg";

	public CrashMannerDrawing(int id, RowVersion version) : base(id, version)
	{
	}

	[JsonIgnore]
	public string Xaml
	{
		get => GetFieldValue<string>(XamlField);
		set => Fields[XamlField] = value;
	}

	[JsonIgnore]
	public string Svg
	{
		get => GetFieldValue<string>(SvgField);
		set => Fields[SvgField] = value;
	}
}