﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// Distraction that may have influenced driver/non-motorist performance, as defined by MMUCC field P18.1.
	/// </summary>
	public class DistractionAction : ReferenceDataBase
	{
		public const string InattentiveTag = "Inattentive";

		public DistractionAction(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsInattentive
		{
			get => Tags.Contains(InattentiveTag);
			set => SetTagPresence(InattentiveTag, value);
		}
	}
}