﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class DriverAction : ReferenceDataBase
	{
		public const string BackingTag = "Backing";
		public const string TurningTag = "Turning";

		[JsonIgnore]
		public bool IsBacking
		{
			get => Tags.Contains(BackingTag);
			set => SetTagPresence(BackingTag, value);
		}

		[JsonIgnore]
		public bool IsTurning
		{
			get => Tags.Contains(TurningTag);
			set => SetTagPresence(TurningTag, value);
		}

		public DriverAction(int id, RowVersion version) : base(id, version)
		{
		}
	}
}