﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class DriverLicenseEndorsement : ReferenceDataBase
	{
		public const string MotorcycleTag = "Motorcycle";
		public const string LaCodeField = "LaCode";

		public DriverLicenseEndorsement(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsMotorcycle
		{
			get => Tags.Contains(MotorcycleTag);
			set => SetTagPresence(MotorcycleTag, value);
		}

		[JsonIgnore]
		public string LaCode
		{
			get => GetFieldValue<string>(LaCodeField);
			set => Fields[LaCodeField] = value;
		}
	}
}