﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class DriverLicenseStatus : ReferenceDataBase
	{
		public const string RequiresLicenseInformationTag = "RequiresLicenseInformation";
		public const string NotLicensedTag = "NotLicensed";
		public const string RegexKey = "Regex";

		public DriverLicenseStatus(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool RequiresLicenseInformation
		{
			get => Tags.Contains(RequiresLicenseInformationTag);
			set => SetTagPresence(RequiresLicenseInformationTag, value);
		}

		[JsonIgnore]
		public bool NotLicensed
		{
			get => Tags.Contains(NotLicensedTag);
			set => SetTagPresence(NotLicensedTag, value);
		}

		[JsonIgnore]
		public string Regex
		{
			get { return GetFieldValue<string>(RegexKey); }
			set { Fields[RegexKey] = value; }
		}

		public bool IsMatchFor(string status)
		{
			string regex = Regex;
			return regex != null && System.Text.RegularExpressions.Regex.IsMatch(status, regex);
		}
	}
}