﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class DriverLicenseType : ReferenceDataBase
	{
		public const string RestrictedTag = "Restricted";
		public const string CommercialTag = "Commercial";

		public DriverLicenseType(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsRestricted
		{
			get => Tags.Contains(RestrictedTag);
			set => SetTagPresence(RestrictedTag, value);
		}

		[JsonIgnore]
		public bool IsCommercial
		{
			get => Tags.Contains(CommercialTag);
			set => SetTagPresence(CommercialTag, value);
		}
	}
}