﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class DrugTestResult : ReferenceDataBase
	{
		public const string ValidForFatalCrashTag = "ValidForFatalCrash";
		public const string ValidForNonFatalCrashTag = "ValidForNonFatalCrash";

		public const string FarsCodeKey = "FarsCode";

		public DrugTestResult(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsValidForFatalCrash
		{
			get => Tags.Contains(ValidForFatalCrashTag);
			set => SetTagPresence(ValidForFatalCrashTag, value);
		}

		[JsonIgnore]
		public bool IsValidForNonFatalCrash
		{
			get => Tags.Contains(ValidForNonFatalCrashTag);
			set => SetTagPresence(ValidForNonFatalCrashTag, value);
		}

		[JsonIgnore]
		public string FarsCode
		{
			get => GetFieldValue<string>(FarsCodeKey);
			set => Fields[FarsCodeKey] = value;
		}
	}
}