﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// Indicates whether the driven vehicle at the time of the crash requires endorsement(s) and whether the driver is complying with them,
	/// as defined by MMUCC field LV1.2.
	/// </summary>
	public class EndorsementCompliance : ReferenceDataBase
	{
		public const string EndorsementsRequiredTag = "EndorsementsRequired";

		[JsonIgnore]
		public bool AreEndorsementsRequired
		{
			get => Tags.Contains(EndorsementsRequiredTag);
			set => SetTagPresence(EndorsementsRequiredTag, value);
		}

		public EndorsementCompliance(int id, RowVersion version) : base(id, version)
		{
		}
	}
}