﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// The class of hazardous materials being transported by a vehicle, as defined by MMUCC field LV10.2.
	/// <para>Hazardous material classes are defined by the FMCSA.  The user will find the class number on the bottom of hazmat placards.</para>
	/// </summary>
	public class HazardousMaterialClass : ReferenceDataBase
	{
		public const string DescribeInNarrativeTag = nameof(DescribeInNarrative);
		
		public HazardousMaterialClass(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool DescribeInNarrative
		{
			get => Tags.Contains(DescribeInNarrativeTag);
			set => SetTagPresence(DescribeInNarrativeTag, value);
		}
	}
}