﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class HitAndRun : ReferenceDataBase
	{
		public const string DriverLeftSceneTag = nameof(DriverLeftScene);
		public const string VehicleLeftSceneTag = nameof(VehicleLeftScene);

		public HitAndRun(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool DriverLeftScene
		{
			get => Tags.Contains(DriverLeftSceneTag);
			set => SetTagPresence(DriverLeftSceneTag, value);
		}

		[JsonIgnore]
		public bool VehicleLeftScene
		{
			get => Tags.Contains(VehicleLeftSceneTag);
			set => SetTagPresence(VehicleLeftSceneTag, value);
		}
	}
}