﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class InjuryStatus : ReferenceDataBase
	{
		// Tag definitions
		public const string FatalTag = "Fatal";
		public const string InjuryTag = "Injury";

		public InjuryStatus(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsFatal
		{
			get => Tags.Contains(FatalTag);
			set => SetTagPresence(FatalTag, value);
		}

		[JsonIgnore]
		public bool IsInjury
		{
			get => Tags.Contains(InjuryTag);
			set => SetTagPresence(InjuryTag, value);
		}
	}
}