﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class LightCondition : ReferenceDataBase
	{
		public LightCondition(int id, RowVersion version) : base(id, version)
		{
		}

		public const string DaylightTag = "Daylight";

		[JsonIgnore]
		public bool IsDaylight
		{
			get => Tags.Contains(DaylightTag);
			set => SetTagPresence(DaylightTag, value);
		}

		public const string DarkTag = "Dark";

		[JsonIgnore]
		public bool IsDark
		{
			get => Tags.Contains(DarkTag);
			set => SetTagPresence(DarkTag, value);
		}

		public const string DawnDuskTag = "DawnDusk";

		[JsonIgnore]
		public bool IsDawnDusk
		{
			get => Tags.Contains(DawnDuskTag);
			set => SetTagPresence(DawnDuskTag, value);
		}
	}
}