﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class LocationSource : ReferenceDataBase
	{
		public const string MapClickTag = nameof(MapClick);
		public const string GpsTag = nameof(Gps);
		public const string ManualEntryTag = nameof(ManualEntry);
		public const string RequiresInternalRouteIdTag = nameof(RequiresInternalRouteId);
		public const string RequiresMilepointTag = nameof(RequiresMilepoint);
		public const string RequiresCoordinatesTag = nameof(RequiresCoordinates);

		public LocationSource(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool MapClick
		{
			get => Tags.Contains(MapClickTag);
			set => SetTagPresence(MapClickTag, value);
		}

		[JsonIgnore]
		public bool Gps
		{
			get => Tags.Contains(GpsTag);
			set => SetTagPresence(GpsTag, value);
		}

		[JsonIgnore]
		public bool ManualEntry
		{
			get => Tags.Contains(ManualEntryTag);
			set => SetTagPresence(ManualEntryTag, value);
		}

		[JsonIgnore]
		public bool RequiresInternalRouteId
		{
			get => Tags.Contains(RequiresInternalRouteIdTag);
			set => SetTagPresence(RequiresInternalRouteIdTag, value);
		}

		[JsonIgnore]
		public bool RequiresMilepoint
		{
			get => Tags.Contains(RequiresMilepointTag);
			set => SetTagPresence(RequiresMilepointTag, value);
		}

		[JsonIgnore]
		public bool RequiresCoordinates
		{
			get => Tags.Contains(RequiresCoordinatesTag);
			set => SetTagPresence(RequiresCoordinatesTag, value);
		}
	}
}