﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	[HideCodes]
	public class MedicalFacility : ReferenceDataBase
	{
		public const string OnlyForFatalInjuryTag = "OnlyForFatalInjury";

		public const string AddressStreetField = "AddressStreet";
		public const string AddressCityField = "AddressCity";
		public const string AddressStateField = "AddressState";
		public const string AddressPostalCodeField = "AddressPostalCode";
		public const string ParishField = "Parish";

		public MedicalFacility(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool OnlyForFatalInjury
		{
			get => Tags.Contains(OnlyForFatalInjuryTag);
			set => SetTagPresence(OnlyForFatalInjuryTag, value);
		}

		[JsonIgnore]
		public string AddressStreet
		{
			get => GetFieldValue<string>(AddressStreetField);
			set => Fields[AddressStreetField] = value;
		}

		[JsonIgnore]
		public string AddressCity
		{
			get => GetFieldValue<string>(AddressCityField);
			set => Fields[AddressCityField] = value;
		}

		[JsonIgnore]
		public string AddressState
		{
			get => GetFieldValue<string>(AddressStateField);
			set => Fields[AddressStateField] = value;
		}

		[JsonIgnore]
		public string AddressPostalCode
		{
			get => GetFieldValue<string>(AddressPostalCodeField);
			set => Fields[AddressPostalCodeField] = value;
		}

		[JsonIgnore]
		public string Parish
		{
			get => GetFieldValue<string>(ParishField);
			set => Fields[ParishField] = value;
		}
	}
}