﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class MedicalTransportationType : ReferenceDataBase
	{
		public const string EmergencyMedicalServiceTag = "EmergencyMedicalService";

		public MedicalTransportationType(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsEmergencyMedicalService
		{
			get => Tags.Contains(EmergencyMedicalServiceTag);
			set => SetTagPresence(EmergencyMedicalServiceTag, value);
		}
	}
}