﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class MotorCarrierIdentificationType : ReferenceDataBase
	{
		public const string RequiresIdentificationStateTag = "RequiresIdentificationState";
		public const string RequiresIdentificationNumberTag = "RequiresIdentificationNumber";
		public const string IdentificationNumberLengthField = "IdentificationNumberLength";
		public const string UsdotNumberTag = "UsdotNumber";
		public const string StateNumberTag = "StateNumber";

		public MotorCarrierIdentificationType(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool RequiresIdentificationState
		{
			get => Tags.Contains(RequiresIdentificationStateTag);
			set => SetTagPresence(RequiresIdentificationStateTag, value);
		}

		[JsonIgnore]
		public bool RequiresIdentificationNumber
		{
			get => Tags.Contains(RequiresIdentificationNumberTag);
			set => SetTagPresence(RequiresIdentificationNumberTag, value);
		}

		[JsonIgnore]
		public int? IdentificationNumberLength
		{
			get => GetFieldValue<int?>(IdentificationNumberLengthField);
			set => Fields[IdentificationNumberLengthField] = value;
		}

		[JsonIgnore]
		public bool IsUsdotNumber
		{
			get => Tags.Contains(UsdotNumberTag);
			set => SetTagPresence(UsdotNumberTag, value);
		}

		[JsonIgnore]
		public bool IsStateNumber
		{
			get => Tags.Contains(StateNumberTag);
			set => SetTagPresence(StateNumberTag, value);
		}
	}
}