﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class MotorCarrierType : ReferenceDataBase
	{
		public const string RequiresMotorCarrierDetailsTag = nameof(RequiresMotorCarrierDetails);
		public const string InterstateTag = "Interstate";
		public const string IntrastateTag = "Intrastate";

		public MotorCarrierType(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool RequiresMotorCarrierDetails
		{
			get => Tags.Contains(RequiresMotorCarrierDetailsTag);
			set => SetTagPresence(RequiresMotorCarrierDetailsTag, value);
		}

		[JsonIgnore]
		public bool IsInterstate
		{
			get => Tags.Contains(InterstateTag);
			set => SetTagPresence(InterstateTag, value);
		}

		[JsonIgnore]
		public bool IsIntrastate
		{
			get => Tags.Contains(IntrastateTag);
			set => SetTagPresence(IntrastateTag, value);
		}
	}
}