﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// Action/circumstance of the non-motorist that may have contributed to the crash, as defined by MMUCC field NM3.
	/// </summary>
	public class NonMotoristContributingCircumstance : ReferenceDataBase
	{
		public const string CyclistTag = "Cyclist";

		[JsonIgnore]
		public bool IsCyclist
		{
			get => Tags.Contains(CyclistTag);
			set => SetTagPresence(CyclistTag, value);
		}

		public NonMotoristContributingCircumstance(int id, RowVersion version) : base(id, version)
		{
		}
	}
}