﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// Location of the non-motorist with respect to the roadway at the time of the crash, as defined by MMUCC field NM4.
	/// </summary>
	public class NonMotoristLocation : ReferenceDataBase
	{
		public const string IntersectionTag = "Intersection";

		public NonMotoristLocation(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsIntersection
		{
			get => Tags.Contains(IntersectionTag);
			set => SetTagPresence(IntersectionTag, value);
		}
	}
}