﻿using ECrash.Core;
using ECrash.Core.Models;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class ParishBorder : ReferenceDataBase
	{
        public const string GeographicLocatorCodeKey = nameof(GeographicLocatorCode);
		public const string BorderKey = nameof(Border);

		public ParishBorder(int id, RowVersion version) : base(id, version)
		{
		}

        [JsonIgnore]
        public string GeographicLocatorCode
        {
            get => GetFieldValue<string>(GeographicLocatorCodeKey);
            set => Fields[GeographicLocatorCodeKey] = value;
        }

		[JsonIgnore]
		public UtmGeographicBorder Border
		{
			get => GetFieldObject<UtmGeographicBorder>(BorderKey);
			set => Fields[BorderKey] = JObject.FromObject(value);
		}

		public bool? IsWithinBorders(decimal latitude, decimal longitude)
		{
			return Border?.IsCoordinateWithin((double)latitude, (double)longitude);
		}
	}
}