﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class Race : ReferenceDataBase
	{
		public const string RegexKey = "Regex";

		public Race(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public string Regex
		{
			get { return GetFieldValue<string>(RegexKey); }
			set { Fields[RegexKey] = value; }
		}

		public bool IsMatchFor(string status)
		{
			string regex = Regex;
			return regex != null && System.Text.RegularExpressions.Regex.IsMatch(status, regex);
		}
	}
}