﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// The restraint equipment in use by the occupant, or the helmet used by a motorcyclist, at the time of the crash, as defined by MMUCC field P8.1.
	/// </summary>
	public class RestraintSystemType : ReferenceDataBase
	{
		public const string MotorcycleTag = "Motorcycle";

		[JsonIgnore]
		public bool IsMotorcycle
		{
			get => Tags.Contains(MotorcycleTag);
			set => SetTagPresence(MotorcycleTag, value);
		}

		public RestraintSystemType(int id, RowVersion version) : base(id, version)
		{
		}
	}
}