﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class RoadSubtype : ReferenceDataBase
	{
		public const string MainlineTag = "Mainline";
		public const string RampTag = "Ramp";
		public const string OnRampTag = "OnRamp";
		public const string OffRampTag = "OffRamp";
		public const string FrontageTag = "Frontage";
		public const string ServiceTag = "Service";

		public RoadSubtype(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsMainline
		{
			get => Tags.Contains(MainlineTag);
			set => SetTagPresence(MainlineTag, value);
		}

		[JsonIgnore]
		public bool IsRamp
		{
			get => Tags.Contains(RampTag);
			set => SetTagPresence(RampTag, value);
		}

		[JsonIgnore]
		public bool IsOnRamp
		{
			get => Tags.Contains(OnRampTag);
			set => SetTagPresence(OnRampTag, value);
		}

		[JsonIgnore]
		public bool IsOffRamp
		{
			get => Tags.Contains(OffRampTag);
			set => SetTagPresence(OffRampTag, value);
		}

		[JsonIgnore]
		public bool IsFrontage
		{
			get => Tags.Contains(FrontageTag);
			set => SetTagPresence(FrontageTag, value);
		}

		[JsonIgnore]
		public bool IsService
		{
			get => Tags.Contains(ServiceTag);
			set => SetTagPresence(ServiceTag, value);
		}
	}
}