﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
    /// <summary>
    /// Indicates the geometric layout of the roadway in this vehicle's direction of travel, as defined by MMUCC field V16.1.
    /// </summary>
	public class RoadwayAlignment : ReferenceDataBase
	{
		public const string NotOnTrafficwayTag = "NotOnTrafficway";

		[JsonIgnore]
		public bool IsNotOnTrafficway
		{
			get => Tags.Contains(NotOnTrafficwayTag);
			set => SetTagPresence(NotOnTrafficwayTag, value);
		}

		public RoadwayAlignment(int id, RowVersion version) : base(id, version)
		{
		}
	}
}