﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class RoadwayEnvironmentalContributingCircumstance : ReferenceDataBase
	{
		public RoadwayEnvironmentalContributingCircumstance(int id, RowVersion version) : base(id, version)
		{
		}

		public const string RoadSurfaceConditionTag = "RoadSurfaceCondition";

		[JsonIgnore]
		public bool IsRoadSurfaceCondition
		{
			get => Tags.Contains(RoadSurfaceConditionTag);
			set => SetTagPresence(RoadSurfaceConditionTag, value);
		}

		public const string TrafficControlDeviceTag = "TrafficControlDevice";

		[JsonIgnore]
		public bool IsTrafficControlDevice
		{
			get => Tags.Contains(TrafficControlDeviceTag);
			set => SetTagPresence(TrafficControlDeviceTag, value);
		}

		public const string WeatherConditionsTag = "WeatherConditions";

		[JsonIgnore]
		public bool IsWeatherConditions
		{
			get => Tags.Contains(WeatherConditionsTag);
			set => SetTagPresence(WeatherConditionsTag, value);
		}

		public const string WorkZoneTag = "WorkZone";

		[JsonIgnore]
		public bool IsWorkZone
		{
			get => Tags.Contains(WorkZoneTag);
			set => SetTagPresence(WorkZoneTag, value);
		}
	}
}