﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class Sex : ReferenceDataBase
	{
		public const string MaleTag = "Male";
		public const string FemaleTag = "Female";

		public Sex(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsMale
		{
			get => Tags.Contains(MaleTag);
			set => SetTagPresence(MaleTag, value);
		}

		[JsonIgnore]
		public bool IsFemale
		{
			get => Tags.Contains(FemaleTag);
			set => SetTagPresence(FemaleTag, value);
		}
	}
}