﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// Indication of whether the investigating officer suspects that the driver involved in the crash was speeding
	/// based on verbal or physical evidence and not on speculation alone, as defined by MMUCC field P13.
	/// </summary>
	public class SpeedingRelation : ReferenceDataBase
	{
		public const string ExceedingSpeedLimitTag = "ExceedingSpeedLimit";

		[JsonIgnore]
		public bool IsExceedingSpeedLimit
		{
			get => Tags.Contains(ExceedingSpeedLimitTag);
			set => SetTagPresence(ExceedingSpeedLimitTag, value);
		}

		public SpeedingRelation(int id, RowVersion version) : base(id, version)
		{
		}
	}
}