﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class TowAuthority : ReferenceDataBase
	{
		public const string LawEnforcementTag = "LawEnforcement";
		public const string OwnerTag = "Owner";

		public TowAuthority(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsLawEnforcement
		{
			get => Tags.Contains(LawEnforcementTag);
			set => SetTagPresence(LawEnforcementTag, value);
		}

		[JsonIgnore]
		public bool IsOwner
		{
			get => Tags.Contains(OwnerTag);
			set => SetTagPresence(OwnerTag, value);
		}
	}
}