﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class TowStatus : ReferenceDataBase
	{
		public const string DueToDisablingDamageTag = "DueToDisablingDamage";

		public TowStatus(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsDueToDisablingDamage
		{
			get => Tags.Contains(DueToDisablingDamageTag);
			set => SetTagPresence(DueToDisablingDamageTag, value);
		}
	}
}