﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// Indicates characteristics of the crash with respect to its location on or off a trafficway, as defined by MMUCC field C2.2.
	/// </summary>
	public class TrafficwayCharacteristics : ReferenceDataBase
	{
		// Tag definitions
		public const string TrafficwayTag = "Trafficway";
		public const string OnRoadTag = "OnRoad";

		public TrafficwayCharacteristics(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsTrafficway
		{
			get => Tags.Contains(TrafficwayTag);
			set => SetTagPresence(TrafficwayTag, value);
		}

		[JsonIgnore]
		public bool IsOnRoad
		{
			get => Tags.Contains(OnRoadTag);
			set => SetTagPresence(OnRoadTag, value);
		}
	}
}