﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
    /// <summary>
    /// Indicates whether or not a motor vehicle's trafficway is divided, as defined by MMUCC field V14.2.
    /// </summary>
	public class TrafficwayDivision : ReferenceDataBase
	{
		public const string DefaultForOneWayTag = "DefaultForOneWay";

		[JsonIgnore]
		public bool IsDefaultForOneWay
		{
			get => Tags.Contains(DefaultForOneWayTag);
			set => SetTagPresence(DefaultForOneWayTag, value);
		}

		public TrafficwayDivision(int id, RowVersion version) : base(id, version)
		{
		}
	}
}