﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
    /// <summary>
    /// Indicates whether a motor vehicle's trafficway serves one-way or two-way traffic, as defined by MMUCC field V14.1.
    /// </summary>
	public class TrafficwayTravelDirection : ReferenceDataBase
	{
		public const string OneWayTag = "OneWay";

		[JsonIgnore]
		public bool IsOneWay
		{
			get => Tags.Contains(OneWayTag);
			set => SetTagPresence(OneWayTag, value);
		}

		public const string TwoWayTag = "TwoWay";

		[JsonIgnore]
		public bool IsTwoWay
		{
			get => Tags.Contains(TwoWayTag);
			set => SetTagPresence(TwoWayTag, value);
		}

		public const string NotOnTrafficwayTag = "NotOnTrafficway";

		[JsonIgnore]
		public bool IsNotOnTrafficway
		{
			get => Tags.Contains(NotOnTrafficwayTag);
			set => SetTagPresence(NotOnTrafficwayTag, value);
		}

		public TrafficwayTravelDirection(int id, RowVersion version) : base(id, version)
		{
		}
	}
}