﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class TrainCollisionType : ReferenceDataBase
	{
		public const string FrontalTag = "Frontal";
		public const string SideTag = "Side";

		public TrainCollisionType(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsFrontal
		{
			get => Tags.Contains(FrontalTag);
			set => SetTagPresence(FrontalTag, value);
		}

		[JsonIgnore]
		public bool IsSide
		{
			get => Tags.Contains(SideTag);
			set => SetTagPresence(SideTag, value);
		}
	}
}