﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class TrainCrossingType : ReferenceDataBase
	{
		public const string PublicTag = "Public";
		public const string PrivateTag = "Private";

		public TrainCrossingType(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsPublic
		{
			get => Tags.Contains(PublicTag);
			set => SetTagPresence(PublicTag, value);
		}

		[JsonIgnore]
		public bool IsPrivate
		{
			get => Tags.Contains(PrivateTag);
			set => SetTagPresence(PrivateTag, value);
		}
	}
}