﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class TrainEquipmentStatus : ReferenceDataBase
	{
		public const string EventDataRecorderEquippedTag = "EventDataRecorderEquipped";

		public TrainEquipmentStatus(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsEventDataRecorderEquipped
		{
			get => Tags.Contains(EventDataRecorderEquippedTag);
			set => SetTagPresence(EventDataRecorderEquippedTag, value);
		}
	}
}