﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class TrainType : ReferenceDataBase
	{
		public const string RailroadTrainTag = "RailroadTrain";
		public const string StreetcarTag = "Streetcar";

		public TrainType(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsRailroadTrain
		{
			get => Tags.Contains(RailroadTrainTag);
			set => SetTagPresence(RailroadTrainTag, value);
		}

		[JsonIgnore]
		public bool IsStreetcar
		{
			get => Tags.Contains(StreetcarTag);
			set => SetTagPresence(StreetcarTag, value);
		}
	}
}