﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class VehicleConfiguration : ReferenceDataBase
	{
		public const string BusTag = "Bus";
		public const string WeightAbove10kTag = "WeightAbove10k";
		public const string Weight10kOrBelowTag = "Weight10kOrBelow";
		public const string TwoAxlesTag = "TwoAxles";
		public const string ThreePlusAxlesTag = "ThreePlusAxles";
		public const string HazardousMaterialsPlacardTag = "HazardousMaterialsPlacard";
		public const string NoTrailerTag = "NoTrailer";
		public const string EndorsementRequiredTag = "EndorsementRequired";

		[JsonIgnore]
		public bool IsBus
		{
			get => Tags.Contains(BusTag);
			set => SetTagPresence(BusTag, value);
		}

		[JsonIgnore]
		public bool IsWeightAbove10k
		{
			get => Tags.Contains(WeightAbove10kTag);
			set => SetTagPresence(WeightAbove10kTag, value);
		}

		[JsonIgnore]
		public bool IsWeight10kOrBelow
		{
			get => Tags.Contains(Weight10kOrBelowTag);
			set => SetTagPresence(Weight10kOrBelowTag, value);
		}

		[JsonIgnore]
		public bool HasTwoAxles
		{
			get => Tags.Contains(TwoAxlesTag);
			set => SetTagPresence(TwoAxlesTag, value);
		}

		[JsonIgnore]
		public bool HasThreePlusAxles
		{
			get => Tags.Contains(ThreePlusAxlesTag);
			set => SetTagPresence(ThreePlusAxlesTag, value);
		}

		[JsonIgnore]
		public bool HasHazardousMaterialsPlacard
		{
			get => Tags.Contains(HazardousMaterialsPlacardTag);
			set => SetTagPresence(HazardousMaterialsPlacardTag, value);
		}

		[JsonIgnore]
		public bool CannotHaveTrailer
		{
			get => Tags.Contains(NoTrailerTag);
			set => SetTagPresence(NoTrailerTag, value);
		}

		[JsonIgnore]
		public bool IsEndorsementRequired
		{
			get => Tags.Contains(EndorsementRequiredTag);
			set => SetTagPresence(EndorsementRequiredTag, value);
		}

		public VehicleConfiguration(int id, RowVersion version) : base(id, version)
		{
		}
	}
}