﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// The extent to which a vehicle's damage affects the vehicle's operability (rather than cost to repair), as defined by MMUCC field V19.3.
	/// </summary>
	public class VehicleDamageExtent : ReferenceDataBase
	{
		public const string DisablingDamageTag = "DisablingDamage";

		[JsonIgnore]
		public bool IsDisablingDamage
		{
			get => Tags.Contains(DisablingDamageTag);
			set => SetTagPresence(DisablingDamageTag, value);
		}

		public VehicleDamageExtent(int id, RowVersion version) : base(id, version)
		{
		}
	}
}