﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	/// <summary>
	/// The location of a vehicle event relative to the trafficway, as defined by MMUCC fields C8.
	/// </summary>
	public class VehicleEventLocation : ReferenceDataBase
	{
		// Tag definitions
		public const string RoadBoundaryTag = "RoadBoundary";
		public const string ParkingLaneTag = "ParkingLane";

		public VehicleEventLocation(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public bool IsRoadBoundary
		{
			get => Tags.Contains(RoadBoundaryTag);
			set => SetTagPresence(RoadBoundaryTag, value);
		}

		[JsonIgnore]
		public bool IsParkingLane
		{
			get => Tags.Contains(ParkingLaneTag);
			set => SetTagPresence(ParkingLaneTag, value);
		}
	}
}