﻿using System;
using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class VehicleFmcsaReportabilityRule : ReferenceDataBase
	{
		public const string VinRegexKey = "VinRegex";
		public const string ReportabilityKey = "Reportability";

		public VehicleFmcsaReportabilityRule(int id, RowVersion version) : base(id, version)
		{
		}

		[JsonIgnore]
		public string VinRegex
		{
			get => GetFieldValue<string>(VinRegexKey);
			set => Fields[VinRegexKey] = value;
		}

		[JsonIgnore]
		public VehicleFmcsaReportability Reportability
		{
			get => Enum.TryParse<VehicleFmcsaReportability>(GetFieldValue<string>(ReportabilityKey), out var value) ? value : default;
			set => Fields[ReportabilityKey] = value.ToString();
		}
	}
}