﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class VehicleManeuver : ReferenceDataBase
	{
		public const string BackingTag = "Backing";
		public const string LeftTag = "Left";
		public const string ParkedTag = "Parked";
		public const string PassingTag = "Passing";
		public const string RightTag = "Right";
		public const string TurningTag = "Turning";

		[JsonIgnore]
		public bool IsBacking
		{
			get => Tags.Contains(BackingTag);
			set => SetTagPresence(BackingTag, value);
		}

		[JsonIgnore]
		public bool IsLeft
		{
			get => Tags.Contains(LeftTag);
			set => SetTagPresence(LeftTag, value);
		}
		[JsonIgnore]
		public bool IsParked
		{
			get => Tags.Contains(ParkedTag);
			set => SetTagPresence(ParkedTag, value);
		}

		[JsonIgnore]
		public bool IsPassing
		{
			get => Tags.Contains(PassingTag);
			set => SetTagPresence(PassingTag, value);
		}

		[JsonIgnore]
		public bool IsRight
		{
			get => Tags.Contains(RightTag);
			set => SetTagPresence(RightTag, value);
		}

		[JsonIgnore]
		public bool IsTurning
		{
			get => Tags.Contains(TurningTag);
			set => SetTagPresence(TurningTag, value);
		}

		public VehicleManeuver(int id, RowVersion version) : base(id, version)
		{
		}
	}
}