﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
    /// <summary>
    /// The motor vehicle type as defined by MMUCC field V2.1.
    /// </summary>
	public class VehicleType : ReferenceDataBase
	{
		public const string ParkedTag = "Parked";

		[JsonIgnore]
		public bool IsParked
		{
			get => Tags.Contains(ParkedTag);
			set => SetTagPresence(ParkedTag, value);
		}

		public const string InTransportTag = "InTransport";

		[JsonIgnore]
		public bool IsInTransport
		{
			get => Tags.Contains(InTransportTag);
			set => SetTagPresence(InTransportTag, value);
		}

		public const string WorkingTag = "Working";

		[JsonIgnore]
		public bool IsWorking
		{
			get => Tags.Contains(WorkingTag);
			set => SetTagPresence(WorkingTag, value);
		}

		public VehicleType(int id, RowVersion version) : base(id, version)
		{
		}
	}
}