﻿using ECrash.Core;
using ECrash.Core.Models.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports.ReferenceData
{
	public class WeatherCondition : ReferenceDataBase
	{
		
		public WeatherCondition(int id, RowVersion version) : base(id, version)
		{
		}

		public const string WetTag = "Wet";

		[JsonIgnore]
		public bool IsWet
		{
			get => Tags.Contains(WetTag);
			set => SetTagPresence(WetTag, value);
		}

		public const string ClearTag = "Clear";

		[JsonIgnore]
		public bool IsClear
		{
			get => Tags.Contains(ClearTag);
			set => SetTagPresence(ClearTag, value);
		}
	}
}