﻿using System.Collections.Generic;
using ECrash.Core.Models.Document;
using ECrashLA.Core.Models.CrashReports.ReferenceData;
using Newtonsoft.Json;

namespace ECrashLA.Core.Models.CrashReports
{
	public class SequenceOfEventsItem : DocumentChild<CrashReport>, INeedsCollectionIndex
	{
		private VehicleEvent _event;
		private string _eventDescription;
		private bool _isMostHarmfulEvent;

		public override IEnumerable<IDocumentNode<CrashReport>> EnumerateChildNodes()
		{
			yield break;
		}

		/// <summary>
		/// Gets or sets the zero-based index of this item.
		/// </summary>
		[JsonIgnore]
		public int Index => (Parent as SequenceOfEvents)?.IndexOf(this) ?? -1;

		/// <summary>
		/// Gets the one-based number of this item.
		/// </summary>
		[JsonIgnore]
		public int Number => Index + 1;

		public VehicleEvent Event
		{
			get => _event;
			set => Set(ref _event, value);
		}

		[MaxLength(200)]
		public string EventDescription
		{
			get => _eventDescription;
			set => Set(ref _eventDescription, value);
		}

		public bool IsMostHarmfulEvent
		{
			get => _isMostHarmfulEvent;
			set => Set(ref _isMostHarmfulEvent, value);
		}

		void INeedsCollectionIndex.OnCollectionIndexChanged()
		{
			NotifyOfPropertyChange(nameof(Index));
			NotifyOfPropertyChange(nameof(Number));
		}
	}
}