﻿using System;

namespace ECrashLA.Core.Models.CrashReports
{
	/// <summary>
	/// A set of flags that indicate whether a vehicle is reportable to FMCSA, and if so, why.
	/// </summary>
	[Flags]
	public enum VehicleFmcsaReportability
	{
		NotReportable                       = 0x00000000,//0
		ReportableDueToVinMatch             = 0x00000001,//1
		ReportableWithReviewDueToVinMatch   = 0x00000002,//2
		ReportableDueToBodyType             = 0x00000010,//16
		ReportableDueToHazardousMaterials   = 0x00000100,//256
        ReportableDueToVehicleConfiguration = 0x00010000, //65536
        ReportableMask                      = 0x0000FFFF,
        ConditiallyReportableMask           = unchecked((int)0xFFFF0000),
    }
}