﻿using System;
using System.Threading.Tasks;
using ECrashLA.Console.Settings;
using Flurl;
using Flurl.Http;
using Spectre.Console;
using Spectre.Console.Cli;

namespace ECrashLA.Console.Commands
{
	public class LoginVendorCommand : AsyncCommand<GetTokenSettings>
	{
		public override async Task<int> ExecuteAsync(CommandContext context, GetTokenSettings settings)
		{
			try
			{
				string token = await settings.Url
				                             .AppendPathSegment("vendor/token/v1")
				                             .PostJsonAsync(new { settings.Username, settings.Password })
				                             .ReceiveString();
				await System.Console.Out.WriteLineAsync(token);
				return 0;
			}
			catch (FlurlHttpException ex)
			{
				AnsiConsole.WriteException(ex);
				return ex.StatusCode ?? -1;
			}
			catch (Exception ex)
			{
				AnsiConsole.WriteException(ex);
				return -1;
			}
		}
	}
}