﻿using System.ComponentModel;
using Spectre.Console;
using Spectre.Console.Cli;

namespace ECrashLA.Console.Settings
{
	public class AuthenticationSettings : WebApiSettings
	{
		[Description("The username to use when authenticating with the web API.")]
		[CommandOption("-u|--user <username>")]
		public string Username { get; set; }

		[Description("The password to use when authenticating with the web API.")]
		[CommandOption("-p|--password <password>")]
		public string Password { get; set; }

		[Description("The token to use when authenticating with the web API.")]
		[CommandOption("-t|--token <token>")]
		public string Token { get; set; }

		public override ValidationResult Validate()
		{
			var result = base.Validate();

			if (Username != null && Token != null)
			{
				result = ValidationResult.Error("You cannot specify both a username and a token.");
			}

			return result;
		}
	}
}