﻿using System;
using System.ComponentModel;
using System.IO;
using Spectre.Console.Cli;

namespace ECrashLA.Console.Settings
{
	public class ModernizeDiagramSettings : AuthenticationSettings
	{
		private string _outputPath;

		[Description("The path to the diagram file to modernize.")]
		[CommandArgument(0, "<diagramPath>")]
		public string DiagramPath { get; set; }

		[Description("The path to the file or folder that will received the modernized diagrams.")]
		[CommandArgument(1, "[outputPath]")]
		public string OutputPath
		{
			get => _outputPath ?? ComputeOutputPathFromDiagramPath();
			set => _outputPath = value;
		}

		private string ComputeOutputPathFromDiagramPath()
		{
			if (DiagramPath == null) return null;
			var fullPath = Path.GetFullPath(DiagramPath);
			return Path.Combine(Path.GetDirectoryName(fullPath) ?? throw new InvalidOperationException(), 
			                    Path.GetFileNameWithoutExtension(fullPath));
		}
	}
}