﻿using System.ComponentModel;
using Spectre.Console.Cli;

namespace ECrashLA.Console.Settings
{
	public class ValidateLocalCrashReportSettings : LocalCrashReportSettings
	{
		[Description("The path to a JSON file containing the eCrash reference data.")]
		[CommandArgument(1, "<referenceDataPath>")]
		public string RefereneDataPath { get; set; }

		[Description("Specifies formatting to apply to the validation report output (Json, Table, or Report).")]
		[CommandOption("-f|--format <format>")]
		[DefaultValue(ValidationReportFormat.Report)]
		public ValidationReportFormat Format { get; set; }
	}
}