﻿using System;
using System.ComponentModel;
using Spectre.Console.Cli;

namespace ECrashLA.Console.Settings
{
	public class VendorDownloadAttachmentSettings : AuthenticationSettings
	{
		[Description("The ID of the crash report containing the attachment to download.")]
		[CommandArgument(0, "<id>")]
		public Guid Id { get; set; }

		[Description("The SHA-1 hash of the attachment to download, in hexadecimal format.")]
		[CommandArgument(1, "<hash>")]
		public string Hash { get; set; }

		[Description("The filename of the attachment to download.")]
		[CommandArgument(2, "<filename>")]
		public string Filename { get; set; }

		[Description("The path to which attachment data should be written.")]
		[CommandArgument(4, "[outputPath]")]
		public string OutputPath { get; set; }
	}
}