﻿using System;
using System.ComponentModel;
using Spectre.Console.Cli;

namespace ECrashLA.Console.Settings
{
	public class VendorDownloadCrashReportPdfSettings : AuthenticationSettings
	{
		[Description("The ID of the crash report to download.")]
		[CommandArgument(0, "<id>")]
		public Guid Id { get; set; }

		[Description("The path to which the crash report PDF should be written.")]
		[CommandArgument(1, "[outputFolder]")]
		public string OutputPath { get; set; }

		[Description("The revision of the crash report to download.")]
		[CommandOption("--revision")]
		public int Revision { get; set; }

		[Description("Omit any attached documents from the PDF.")]
		[CommandOption("--omitAttachments")]
		public bool OmitAttachments { get; set; }
		
		[Description("Omit any photos from the PDF.")]
		[CommandOption("--omitPhotos")]
		public bool OmitPhotos { get; set; }

		[Description("Redacts sensitive data on the PDF.")]
		[CommandOption("--redact")]
		public bool Redact { get; set; }
	}
}