﻿using System;
using System.ComponentModel;
using Spectre.Console.Cli;

namespace ECrashLA.Console.Settings;

public class VendorDownloadFilteredCrashReportDataSettings : AuthenticationSettings
{
	[Description("The ID of the agency for which you are downloading crash reports.")]
	[CommandArgument(0, "<agencyId>")]
	public Guid AgencyId { get; set; }

	[Description("The name of the filter to apply to the crash report data.")]
	[CommandArgument(1, "<filterName>")]
	public string Filter { get; set; }

	[Description("The last RowVersion you have seen when downloading crash reports.")]
	[CommandOption("-v|--version <row-version>")]
	[DefaultValue("0000000000000000")]
	public string RowVersion { get; set; }
}