﻿using System.ComponentModel;
using Spectre.Console.Cli;

namespace ECrashLA.Console.Settings
{
	public class WebApiSettings : CommandSettings
	{
#if TEST
		private const string DefaultUrl = "https://laecrash-test.caps.ua.edu/api/";
#elif UAT
		private const string DefaultUrl = "https://ecrash-test.la.gov/api/";
#elif RELEASE
		private const string DefaultUrl = "https://ecrash.la.gov/api/";
#else
		private const string DefaultUrl = "https://localhost:44339/api/";
#endif

		[Description($"The URL of the web API. (default: \"{DefaultUrl}\")")]
		[CommandOption("-a|--api <url>")]
		[DefaultValue(DefaultUrl)]
		public string Url { get; set; }
	}
}